var api = {
    
    links: {
        cities: "cities",
        categories: "categories",
        sources: "sources",
        deals: "deals",
        deal: "deals?id={id}",
        nearCity: "nearestCityByGeocoordinates?lat={lat}&lng={lng}",
        guid: "getGuid?sg={sg}",
        apnRegister: "apnRegister?push_token={pushToken}&platform={platform}&guid={guid}&sg={sg}",
        emailFrequency: "emailFrequency",
        createUser: "createUser",
        loginUser: "loginUser",
        logoutUser: "logoutUser",
        updateUser: "updateUser",
        changePassword: "changePassword",
        locationDevice: "locationDevice",
        newDealsNotification: "newDealsNotification"
    },
    getUrl: function(key, params) {
        var url = (DomainUrlApi + api.links[key]);
        if( params ) {
            $.each(params, function(k, v) {
                var pattern = new RegExp('{'+k+'}', "g");
                url = url.replace(pattern, v);
            });
        }
        return url.toString();
    },
    setNewDealsNotification: function(notify) {
        var url = api.getUrl('newDealsNotification');
        var guid = Vocabulary.guid;
        var data = {
            guid: guid,
            notify: notify,
            sg: app.getSignature(guid)
        };
        $.ajax({
            method: 'post',
            url: url,
            data: data,
            success: function (data) {
                if( data.error ) {
                    _log('api.setNewDealsNotification', 'error', data.error);
                } else {
                    _log('api.setNewDealsNotification', 'ok');
                }
            }
        });
    },
    setLocationDevice: function(location) {
        var url = api.getUrl('locationDevice');
        var guid = Vocabulary.guid;
        var data = {
            guid: guid,
            city_name: location,
            sg: app.getSignature(guid)
        };
        $.ajax({
            method: 'post',
            url: url,
            data: data,
            success: function (data) {
                if( data.error ) {
                    _log('api.setLocationDevice', 'error', data.error);
                } else {
                    _log('api.setLocationDevice', 'ok');
                }
            }
        });
    },
    getDealsUrl: function (params) {
        var _params = {};

        _params.epi = parseInt(params.epi) || epi;
        _params.limit = parseInt(params.limit) || 14;
        _params.offset = parseInt(params.offset) || 0;
        _params.itemID = parseInt(params.itemID) || null;
        _params.categoryID = parseInt(params.categoryID) || null;
        _params.query = params.query || null;
        _params.city = params.city || 'national';
        _params.lat = params.lat || null;
        _params.lng = params.lng || null;
        _params.guid = Vocabulary.guid;

        if (_params.city == 'Near me' || decodeURIComponent(_params.city) == 'Near me' || decodeURIComponent(decodeURIComponent(_params.city)) == 'Near me') {
            if (Vocabulary.coordinates && Vocabulary.coordinates.lat != null && Vocabulary.coordinates.lng != null && Vocabulary.coordinates.lat != false && Vocabulary.coordinates.lng != false) {
                _params.city = null;
                _params.lat = Vocabulary.coordinates.lat;
                _params.lng = Vocabulary.coordinates.lng;
            } else {
                _params.city = 'national';
            }
        }

        if (_params.city == 'National Deals' || decodeURIComponent(_params.city) == 'National Deals' || decodeURIComponent(decodeURIComponent(_params.city)) == 'National Deals') {
            _params.city = 'national';
        }

        if (_params.query) {
            _params.city = null;
            _params.lat = null;
            _params.lng = null;
            _params.categoryID = null;
        }

        var url = this.getUrl('deals');
        var tmp = [];
        $.each(_params, function (k, v) {
            if (v !== null) {
                tmp.push(k + '=' + v);
            }
        });

        return url + '?' + tmp.join('&');
    }   
};