var isErrorAjaxRequest = false;
var isReadyDevice = false;
var isStartReceiveGEO = false;
var leave = false;
var isMobileVersion = true;
var isMap = false;

if (typeof cordova === 'undefined') {
    isMobileVersion = false;
}

// weinre --boundHost 192.168.0.206
if( false ) {
    var js = document.createElement("script");
    js.src = 'http://192.168.0.206:8080/target/target-script-min.js';
    document.head.appendChild(js);
}

var Vocabulary = {
    coordinates: {
        lat: null,
        lng: null
    },
    loadingTimer: null,
    cities: null,
    nearCity: null,
    categories: null,
    sources: null,
    guid: null,
    sourcesIndex: {},
    deals: [],
    dealsAll: [],
    dealsLastFound: false,
    dealsNoConnection: false,
    dealsCanUpload: true,
    dealsIndex: {},
    deal: null,
    firstInit: null,
    clientWidth: 0,
    clientHeight: 0
};

var app = {
    pageName: null,
    user: null,
    favorite: null,
    dataLoading: 4,
    reload: 0,
    device: {
        model: null,
        platform: null,
        version: null,
        uuid: null
    },
    isRateAbility: false,
    version: null,
    signatureSeparator: '',
    pushToken: null,
    getSignature: function () {
        var _arguments = (Array.prototype.slice.call(arguments));
        _arguments.unshift(SALT);
        return MD5(_arguments.join(app.signatureSeparator));
    },
    logEvent: function (category, action, label, params) {
        if (!isMobileVersion) {
            return;
        }

        label = label || "";

        action = decodeEntities(action);
        label = decodeEntities(label);

        if (window.plugins && window.plugins.flurry) {
            if (params != undefined && typeof params == 'object') {
                window.plugins.flurry.logEventWithParameters(action, params);
                _log('flurry', 'logEventWithParameters', action);
            } else {
                window.plugins.flurry.logEvent(action);
                _log('flurry', 'logEvent', category, action, label);
            }

            if (action == 'pageView') {
                window.plugins.flurry.logPageView();
                analytics.trackView(params.title);
            }
        } else {
            _log('noflurry');
        }

        if (GAInit) {
            params = params || {};
            var value = JSON.stringify(params);
            analytics.trackEvent(category, action, label, value);
            _log('analytics.trackEvent', category, action, label, value);
        }
    },
    checkExpiringPopup: function() {       
        var expiringCount = app.favorite.hasExpiringDeals();

        if( !getCache('checkExpiringDealsFlag') && expiringCount > 0 ) {
            navigator.notification.confirm(
                'There are ' + expiringCount + ' deals about to be expired',
                function (button) {
                    if (button == '1') {
                        location.href = 'favorites.html?sort=expiring';
                    }
                },
                'Favorites',
                ['Show deals','Skip']
            );
        }
        saveCache('checkExpiringDealsFlag', true);
    },
    checkRatePopup: function () {
        if (isMobile.iOS()) {
            if (window.device && parseInt(window.device.version) >= 7) {
                reviewURL = "itms-apps://itunes.apple.com/app/id" + IOS_APP_ID;
            } else {
                reviewURL = "itms-apps://itunes.apple.com/WebObjects/MZStore.woa/wa/viewContentsUserReviews?id=" + IOS_APP_ID + "&onlyLatestVersion=true&pageNumber=0&sortOrdering=1&type=Purple+Software";
            }
        } else if (isMobile.Android()) {
            reviewURL = "market://details?id=" + ANDROID_APP_ID;
        }

        var ratePopupStatus = getCache('ratePopupStatus', 'local');

        if (ratePopupStatus) {
            app.isRateAbility = true;
        }

        if (getCache('checkRatePopupFlag') || ratePopupStatus == 1 || ratePopupStatus == 3) {
            return;
        }
        saveCache('checkRatePopupFlag', true);

        function normalize(statistics) {
            var out = [];
            var start = moment().subtract(14, 'days').format('X');
            $.each(statistics, function (k, v) {
                if (v > start) {
                    out.push(v);
                }
            });

            return out.sort().reverse();
        }

        function getPeriods() {
            var periods = [];
            periods[0] = moment();
            periods[1] = moment().subtract(7, 'days');
            periods[2] = moment(periods[1]).subtract(7, 'days');
            return periods;
        }

        var periods = getPeriods();

        var statistics = getCache('statistics', 'local') || [];

        statistics.push(moment().format('X'));
        statistics = normalize(statistics);
        saveCache('statistics', JSON.stringify(statistics), 'local');
        _log('app.checkRatePopup', 'Save visit');
        
        var showPopup = false;
        for (var i = 1; i < periods.length; i++) {
            var count = 0;

            var start = periods[i];
            var end = periods[i - 1];
            //_log('Period ' + i + ':', start.format('DD.MM.YYYY'), '-', end.format('DD.MM.YYYY'));

            $.each(statistics, function (k, v) {
                if (v > (start.format('X')) && v < (end.format('X'))) {
                    count++;
                }
            });

            if (count >= 3) {
                //_log('Visits per week:', count );
                showPopup = true;
                break;
            }
        }

        if (showPopup) {
            navigator.notification.confirm(
                'If you enjoy using ' + appName + ', would you mind taking a moment to rate it? It won\'t take more than a minute. Thanks for your support!',
                function (button) {
                    if (button == '1') {    // Rate Now
                        window.open(reviewURL, "_system");
                    }
                    _log('app.checkRatePopup', 'Show Popup', 'Choose', button);
                    saveCache('ratePopupStatus', button, 'local');
                    app.isRateAbility = true;
                },
                'Rate ' + appName,
                ['Rate Us','Remind me later','No Thanks']
            );
        }
    },
    initialize: function (needClear) {
        _log('app.initialize');

        var p = location.pathname.split('/');
        app.pageName = p[p.length - 1];

        FastClick.attach(document.body);

        app.user = userObject.init();

        if (app.user.isAuth) {
            $("#login-link, #signup-link").hide();
            $("#profile-link, #logout-link").show();
        }

        $("#profile-link").show();

        document.documentElement.style.webkitTouchCallout = "none";
        document.documentElement.style.webkitUserSelect = "none";

        if (useGEOMandatory) {
            app.dataLoading++;
        }

        this.deviceType = (navigator.userAgent.match(/iPad/i)) == "iPad" ? "iPad" : (navigator.userAgent.match(/iPhone/i)) == "iPhone" ? "iPhone" : (navigator.userAgent.match(/Android/i)) == "Android" ? "Android" : (navigator.userAgent.match(/BlackBerry/i)) == "BlackBerry" ? "BlackBerry" : "null";

        if (needClear) {
            clearCacheAll();
            clearCacheAll('local');
        }

        this.bindEvents();

        if (isAlt) {
            this.initAlt();
        } else {
            this.initDefault();
        }

        $(window).on('resize load', function (e) {
            if (e.type === 'load' || (typeof app.orientation == undefined || app.orientation !== window.orientation)) {
                fixPageContainer();
                app.orientation = window.orientation;
            }
        });

        if (!isMobileVersion) {
            setTimeout(function () {
                $(document).trigger('deviceready');
            }, 100);
        }
        
        var menuDiv = $('.navbar-collapse').find('.ui-listview');
        if( menuDiv.length > 0 ) {
            $.each(menu, function(i, item) {
                var li = $('<li></li>');
                var a = $('<a>'+item.ancor+'</a>');
                a.addClass('ui-btn ui-btn-icon-right ui-icon-carat-r');

                var pattern = new RegExp(RegExp.escape(item.href)+'$', "gi");
                if( pattern.test(decodeURIComponent(location.href)) !== true ) { //|| /index.html/.test(location.href)
                    a.attr('href', item.href);
                }
                
                a.attr('data-href', item.href);

                li.append(a);

                if( item.class ) {
                    li.addClass(item.class);
                }

                if( item.id ) {
                    li.attr('id', item.id);
                }

                menuDiv.append(li);
            });
        }
    },
    initAlt: function () {
        app.favorite = favoriteObject.init();
    },
    initDefault: function () {
        if (useCategories != true) {
            //$("#topCategories").hide();
            $("#categoryLink").remove();
        }

        if (useLocations != true) {
            $("#localDiv").hide();
        }
    },
    bindEvents: function () {
        document.addEventListener('backbutton', this.onBackKeyDown, false);
        document.addEventListener('resume', this.onResume, false);
        document.addEventListener('pause', this.onPause, false);
        document.addEventListener('hidekeyboard', function () {
            var height = $('.page-content').height();
            $('.page-content').height(height + 5);

            setTimeout(function () {
                fixPageContainer();
            }, 150);
        }, false);

        app.receiveInitData();

        $(".link-back").on("click", function (e) {
            app.onBackKeyDown(e);
        });

        $('body').on('click', function (e) {
            if ($(".navbar-collapse").hasClass("in") && $(e.target).parents(".navbar-collapse").length != 1) {
                e.preventDefault();
                $('.collapse').collapse('hide');
            }
        });

        $(window).on('beforeunload', function () {
            leave = true;
        });
    },
    // Update DOM on a Received Event
    receiveInitData: function () {
        if (isAlt) {
            app.initFirstStart();
        }

        app.getApiCities();
        app.getApiCategories();
        app.getApiSources();
        app.getApiGuid();
    },
    apnRegister: function (pushToken) {
        app.pushToken = getCache('pushToken', 'local') || false;
        
        if( isDebug ) {
            //alert('http://yellowcats-mac.local/api/push.php?uuid=' + app.device.uuid + '&version=' + app.device.version + '&platform=' + app.device.platform + '&model=' + app.device.model + '&token=' + pushToken);
            //$.get('http://yellowcats-mac.local/api/push.php?uuid=' + app.device.uuid + '&version=' + app.device.version + '&platform=' + app.device.platform + '&model=' + app.device.model + '&token=' + pushToken);
            $.get('http://146.185.166.184/push/push.php?uuid=' + app.device.uuid + '&app=' + appName + '&version=' + app.device.version + '&platform=' + app.device.platform + '&model=' + app.device.model + '&token=' + pushToken);
        }
        
        if( app.pushToken && app.pushToken == pushToken ) {
            _log('app.apnRegister', 'pushToken already exists', app.pushToken);
            return;
        }
        
        saveCache('pushToken', pushToken, 'local');
        
        app.pushToken = pushToken;
        
        var platform = 'android';
        if( isMobile.iOS() ) {
            platform = 'ios';
        }
        
        var guid = Vocabulary.guid;

        var url = api.getUrl('apnRegister', {
            pushToken: app.pushToken,
            platform: platform,
            guid: guid,
            sg: app.getSignature(guid)
        });
        
        app.sendRequest({
            log: ['app.apnRegister', url],
            url: url,
            success: function(data){
                if( data.error ) {
                    _log('app.apnRegister', 'error', data.error);
                } else {
                    _log('app.apnRegister', 'success', data);
                }
            },
            error: app.errorRequest,
        });
    },
    errorRequest: function () {
        _log('app.errorRequest', 'showNoConnectionScreen');
        showNoConnectionScreen();
    },
    initFirstStart: function () {
        Vocabulary.firstInit = getCache('firstInit');
        Vocabulary.clientWidth = getCache('clientWidth');
        Vocabulary.clientHeight = getCache('clientHeight');
    },
    initFirst: function () {
        Vocabulary.firstInit = 1;
        Vocabulary.clientWidth = $(window).width();
        Vocabulary.clientHeight = $(window).height();

        saveCache('firstInit', Vocabulary.firstInit);
        saveCache('clientWidth', Vocabulary.clientWidth);
        saveCache('clientHeight', Vocabulary.clientHeight);
    },
    sendRequestQuery: null,
    reSendRequest: function () {
        if (sendRequestQuery) {
            sendRequestQuery();
        }
    },
    sendRequest: function (object) {
        var ajaxTime = new Date().getTime();
        var log = object.log || [];
        var complete = object.complete || false;

        $.ajax({
            url: object.url,
            type: object.type || 'GET',
            cache: object.cache || true,
            cache: false,
            dataType: object.dataType || 'json',
            complete: function (e) {
                var totalTime = (new Date().getTime() - ajaxTime) / 1000;

                log.push('request time: ' + totalTime + ' sec');
                log.push('request status: ' + e.status);
                log.push('request statusText: ' + e.statusText);

                _log(log.join(' | '));

                if (complete) {
                    complete();
                }
            },
            success: object.success,
            error: object.error,
            timeout: ajaxRequestTimeout
        });
    },
    getApiCities: function () {
        Vocabulary.cities = getCache('cities');
        if (!Vocabulary.cities) {
            var url = api.getUrl('cities');
            app.sendRequest({
                log: ['app.getApiCities', url],
                url: url,
                success: function (data) {
                    getDataSuccess(data, ['cities'], 'local');
                },
                error: app.errorRequest,
            });
        } else {
            app.dataLoading--;
        }
    },
    getApiCategories: function () {
        Vocabulary.categories = getCache('categories');
        if (!Vocabulary.categories) {
            var url = api.getUrl('categories');
            app.sendRequest({
                log: ['app.getApiCategories', url],
                url: url,
                success: function (data) {
                    getDataSuccess(data, ['categories'], 'local');
                },
                error: app.errorRequest,
            });
        } else {
            app.dataLoading--;
        }
    },
    getApiSources: function () {
        Vocabulary.sources = getCache('sources');
        if (!Vocabulary.sources) {
            var url = api.getUrl('sources');
            app.sendRequest({
                log: ['app.getApiSources', url],
                url: url,
                success: function (data) {
                    getDataSuccess(data, ['sources', 'createIndex'], 'local');
                },
                error: app.errorRequest,
            });
        }
        else {
            Vocabulary.sourcesIndex = getCache('sourcesIndex');
            app.dataLoading--;
        }
    },
    getApiGuid: function () {
        Vocabulary.guid = getCache('guid', 'local');
        if( !Vocabulary.guid ) {
            
            app.dataLoading--;
            
            var url = api.getUrl('guid', {sg: app.getSignature()});

            app.sendRequest({
                log: ['app.getApiGuid', url],
                url: url,
                success: function(data){
                    if( data.error ) {
                        _log('app.getApiGuid', 'error', data.error);
                    } else {
                        Vocabulary.guid = data;
                        saveCache('guid', Vocabulary.guid, 'local');
                        _log('app.getApiGuid', 'guid', Vocabulary.guid);
                    }
                },
                error: app.errorRequest,
            });
        } else {
            _log('app.getApiGuid', 'guid already exists', Vocabulary.guid);
            app.dataLoading--;
        }  
    },
    getApiDeal: function (id, callback) {
        var url = app.ApiUrlLinks.deal.toString().replace(/\{id\}/, parseInt(id));

        app.sendRequest({
            log: ['app.getApiDeal', url],
            url: url,
            success: function (data) {
                getDealSuccess(data);
                if (callback) {
                    callback(data);
                }
            },
            error: app.errorRequest,
        });
    },
    getDeal: function (id, callback) {
        app.dataLoading++;
        if (Vocabulary.dealsIndex[id] != undefined) {
            Vocabulary.deal = Vocabulary.dealsAll[Vocabulary.dealsIndex[id]];
            app.dataLoading--;
            callback();
        } else {
            app.getApiDeal(id, callback);
        }
    },
    getApiDeals: function (params, callbackFunc, isAppend, appendFunc) {
        var url = api.getDealsUrl(params);

        app.sendRequest({
            log: ['app.getApiDeals', url],
            url: url,
            cache: false,
            success: function (data) {
                _log('app.getApiDeals', 'success');
                Vocabulary.dealsNeedAppend = false;
                Vocabulary.dealsNoConnection = false;
                getDealsSuccess(data, params.limit);
                if (callbackFunc) {
                    callbackFunc();
                }

                Vocabulary.dealsCanUpload = true;
                if (Vocabulary.dealsNeedAppend) {
                    if (appendFunc) {
                        appendFunc();
                    }
                } else {
                    $(document).trigger('readyToShow');
                }
            },
            error: function () {
                _log('app.getApiDeals', 'error');
                if (Vocabulary.dealsAll && Vocabulary.dealsAll.length) {
                    Vocabulary.dealsNoConnection = true;
                }
                else {
                    app.errorRequest();
                }
                Vocabulary.dealsCanUpload = true;
            }
        });
    },

    getDeals: function (params, callbackFunc, isAppend, appendFunc) {
        if (Vocabulary.dealsCanUpload) {
            Vocabulary.dealsCanUpload = false;

            app.dataLoading++;
            this.getApiDeals(params, callbackFunc, isAppend, appendFunc);
        }
    },
    onPause: function () {
        app.logEvent('App', 'Pause');
    },
    onResume: function () {
        app.logEvent('App', 'Resume');
    },
    notificationCallbacks: {
        showDeal: function (params) {
            alert( params.dealID )
        },
        showWebPage: function (params) {
            alert( params.href )
        }
    },
    onNotificationAPN: function(e) {
        console.log(JSON.stringify(e));
        
        if ( e.alert ) {
            //alert( e.alert )
            navigator.notification.alert(e.alert);
        }

        if ( e.sound ) {
            var snd = new Media(e.sound);
            snd.play();
        }

        if ( e.badge ) {
            pushNotification.setApplicationIconBadgeNumber(successHandler, errorHandler, e.badge);
        }
    },
    onNotification: function (e) {
        
        //console.log(JSON.stringify(e));
        
        switch (e.event) {
            case 'registered':
                if (e.regid.length > 0) {
                    app.apnRegister(e.regid);
                }
                break;
            case 'message':
                var force = true;
                var callback = e.payload.callback || false;
                var callbackParams = e.payload.callbackParams || {};
                
                if( callback && e.payload.force !== 'undefined' && e.payload.force == 0 ) {
                    force = false;
                }
                
                var buttons = force ? ['OK'] : ['OK','Cancel'];
                navigator.notification.confirm(
                    e.message,
                    function(button) {
                        if( button === 1 ) {
                            if( callback && app.notificationCallbacks[callback] ) {
                                app.notificationCallbacks[callback](callbackParams);
                            }
                        }
                    },
                    e.payload.title,
                    buttons
                );
        
                if( e.foreground && e.payload.sound && e.payload.sound > 0 ) {
                    var soundfile = e.soundname || e.payload.sound;
                    var my_media = new Media("/android_asset/www/" + soundfile);
                    my_media.play();
                }
                break;

            case 'error':
                //$("#app-status-ul").append('<li>ERROR -> MSG:' + e.msg + '</li>');
                break;

            default:
                //$("#app-status-ul").append('<li>EVENT -> Unknown, an event was received and we do not know what it is</li>');
                break;   
        }
    },
    initPushNotifications: function() { 
        var pushNotification = window.plugins.pushNotification;

        if( isMobile.iOS() ) {
            pushNotification.register(
                function (result) {  
                    app.apnRegister(result);
                },
                function (error) {
                    _log('app.initPushNotifications', 'pushNotification', 'errorHandler', error);
                },
                {
                    badge: 'true',
                    sound: 'true',
                    alert: 'true',
                    ecb: 'app.onNotificationAPN'
                }
            );
        } else {
            pushNotification.register(
                function (result) {
                    _log('app.initPushNotifications', 'pushNotification', 'successHandler', result);
                },
                function (error) {
                    _log('app.initPushNotifications', 'pushNotification', 'errorHandler', error);
                },
                {
                    senderID: pushNotificationSenderID,
                    ecb: 'app.onNotification'
                }
            );
        }
    },
    initDeviceInfo: function() {
        if (window.device.model) {
            app.device.model = window.device.model;
        }
        if (window.device.platform) {
            app.device.platform = window.device.platform;
        }
        if (window.device.version) {
            app.device.version = window.device.version;
        }
        if (window.device.uuid) {
            app.device.uuid = window.device.uuid;
        }

        cordova.getAppVersion(function (version) {
            app.version = version;

            var href = 'mailto:' + bugEmail + '?subject=' + appName + '%20app%20feedback%20(version%20' + version + ')';
            $(".mailTo").data("href", href);
            $("#version").html('v. ' + version);
        });
    },
    initGA: function () {
        if( analytics != undefined ) {
            analytics.startTrackerWithId(GA);
            GAInit = true;
        }
        _log('app.initGA', GAInit);
    },
    checkConnection: function() {
        if (navigator.network.connection.type == Connection.NONE) {
            showNoConnectionScreen();
            return false;
        }
    },
    initGeo: function() {
        var isInitDevice = getCache('isInitDevice') || false;
        var successCallback = function () {
            $('.nearme-link').show();
        };

        if (!isInitDevice) {
            geo.init({force: true}).getCoordinates({successCallback: successCallback});
            saveCache('isInitDevice', true);
        } else {
            geo.init({force: false}).getCoordinates({successCallback: successCallback});
        }
        if (Vocabulary.coordinates && Vocabulary.coordinates.lat != null && Vocabulary.coordinates.lng != null && Vocabulary.coordinates.lat != false && Vocabulary.coordinates.lng != false) {
            successCallback();
        }
    },
    initFlurry: function () {
        if( window.plugins && window.plugins.flurry ) {
            var isInitFlurry = getCache('isInitFlurry') || false;
            if( isInitFlurry === false ) {
                window.plugins.flurry.startSession(flurryKey);
                _log('app.initFlurry', 'Starting Flurry Session');
                saveCache('isInitFlurry', true);
            }
        } else {
            _log('app.initFlurry', 'Starting Flurry Session Error');
        }
    },
    onDeviceReady: function () {
        _log('app.onDeviceReady');
        
        isReadyDevice = true;

        _log('--------------- ' + app.pageName + ' ---------------');

        if (isMobileVersion) {
            app.initFlurry();
            app.checkConnection();
            app.initPushNotifications();
            app.initDeviceInfo();
            app.initGA();
            
            if( isAlt && app.user.data.alertWhenExpire > 0 ) {
                app.checkExpiringPopup();
            }
            
            app.checkRatePopup();
        }
        
        app.logEvent('App', 'pageView', 'Enter to the page', {title: app.pageName});
        
        app.initGeo();
    },
    onBackKeyDown: function (e) {
        _log('app.onBackKeyDown');

        e.preventDefault();

        if ($(".navbar-collapse").hasClass("in")) {
            $(".navbar-collapse").collapse("hide");
        } else {
            var dealId = parseInt(getCache('dealId'));

            if ((location.pathname.match(/favorites.html/i)) && dealId) {
                prepareDeals(dealId);
                loading('hide');
            } else if ((location.pathname.match(/index.html/i)) && dealId) {
                if (isAlt) {
                    if (isMap) {
                        isMap = false;
                        $('#dealInfoMap').hide().css('z-index', -1);
                    } else {
                        prepareSwipeDeals(dealId);
                        $('#dealsConteiner .box-deal').css('top', $('#deals .page-content:visible').height() / 2 - $('.box-deal').height() / 2 - 10);
                    }
                } else {
                    //window.history.back();
                    
                    var indexLink = $('#national-deals > a');
                    indexLink.removeAttr('href');
                    
                    
                    prepareDeals();
                    saveCache('dealId', 0);
                    
                    //window.history.pushState('', '', location.href + '&dealId='+id);
                    
                    
                }
                loading('hide');
            } else if (location.pathname.match(/index.html/i) && location.search == "" && location.hash == "") {
                navigator.app.exitApp();
            } else {
                
                if( window.history.length == 1 && location.pathname.match(/intro.html/i) ) {
                    navigator.app.exitApp();
                }
                
                window.history.go(-1);
            }
        }
    },
    runAfterLoad: function (runFunc, errorFunc) {
        if (app.dataLoading == 0) {
            clearTimeout(this.timer);
            runFunc();
            return true;
        }

        if (isErrorAjaxRequest) {
            if (errorFunc) {
                errorFunc();
            }
            return false;
        }
        //if( app.reload < 15 ) {
        this.timer = window.setTimeout(function () {
            app.reload++;
            //_log('reload', app.reload, app.dataLoading);
            app.runAfterLoad(runFunc);
        }, 250);
        //} else {
        //    clearTimeout(this.timer);
        //    alert('Reload Problem');
        //    return false;
        //}
    }
};

function getDataSuccess(data, vars, storage) {
    if( data ) {
        var JSON_object = (typeof (data) == 'object') ? data : eval('(' + data + ')');
        if( vars ) {
            if( vars[0] && JSON_object ) {
                Vocabulary[vars[0]] = JSON_object[vars[0]];
                saveCache(vars[0], JSON.stringify(JSON_object[vars[0]]));
                app.dataLoading--;

                if (vars.indexOf('createIndex') > 0) {
                    for (var i = 0; i < Vocabulary[vars[0]].length; i++) {
                        Vocabulary[vars[0] + 'Index'][Vocabulary[vars[0]][i]['id']] = i;
                    }
                    if (storage == 'local') {
                        saveCache(vars[0] + 'Index', JSON.stringify(Vocabulary[vars[0] + 'Index']), 'local');
                    } else {
                        saveCache(vars[0] + 'Index', JSON.stringify(Vocabulary[vars[0] + 'Index']));
                    }
                }
            }
            return true;
        }
    }
    _log('getDataSuccess', 'bad JSON');
    showNoConnectionScreen();
    return false;
}

function getDealSuccess(data) {
    if (data) {
        var JSON_object = (typeof (data) == 'object') ? data : eval('(' + data + ')');
        Vocabulary.deal = JSON_object['deals'][0];
        app.dataLoading--;
    }
    _log('getDealSuccess', 'bad JSON');
    showNoConnectionScreen();
    return false;
}

function getDealsSuccess(data, maxCountItems) {
    Vocabulary.deals = [];

    if (data) {
        var JSON_object = (typeof (data) == 'object') ? data : eval('(' + data + ')');
        var deals = JSON_object['deals'];

        if (deals) {
            var countAllDeals = 0;
            if (Vocabulary.dealsAll) {
                countAllDeals = Vocabulary.dealsAll.length;
            }

            var count = Vocabulary.deals.length;

            var deal;
            for (var i = 0; i < deals.length; i++) {
                deal = deals[i];
                if( isAlt && app.favorite.exists(deal.ID) ) {
                    if (isDebugDeals) {
                        console.log('SKEEP ID:=' + deal.ID);
                    }
                    continue;
                }
                    
                if (isDebugDeals) {
                    console.log('DEAL ID:=' + deal.ID + ', count:= ' + count);
                }

                Vocabulary.dealsIndex[deal.ID] = countAllDeals;
                Vocabulary.dealsAll[countAllDeals] = deal;
                Vocabulary.deals[count] = deal;
                countAllDeals++;
                count++;
            }
            
            if( isAlt ) {
                if (isDebugDealsOnlyFirst) {
                    Vocabulary.dealsLastFound = true;
                }

                if (maxCountItems && deals.length < maxCountItems) {
                    Vocabulary.dealsLastFound = true;
                    _log('getDealsSuccess', 'Found last deal');
                } else {
                    if (!Vocabulary.dealsLastFound) {
                        if (Vocabulary.deals.length <= 5) {
                            Vocabulary.dealsNeedAppend = true;
                        }
                    }
                }
            }
        }
        app.dataLoading--;
    } else {
        Vocabulary.dealsNoConnection = true;
        return false;
    }
}