    var imageContainerW = 0;
    var imageContainerH = 0;
    
    var imageNewSecondType = "";
    
    var isSwipeMarginSecondDeal = true;

    var isSwipeProcess = false;
    var isSwipeInAnimate = false;
    var isSwipeNextContainerID = "";
    
    //var isSwipeMovingProcess = false;
    var swipeDirectionOldX = "";
    var swipeDirectionOldY = "";
    
    var swipeMouseStartX = 0;
    var swipeMouseStartY = 0;
    var swipeMouseTouchPart = "";
     
    var favoriteObject = {
        deals: {
            rejected: {},
            favorites: {}
        },
        init: function() {
            var self = this;
            self.deals = getCache('deals', 'local') || self.deals;
            self.oldVersionCompatibility();
            self.clearOld();
            return self;
        },
        oldVersionCompatibility: function() {
            if( getCache('oldVersionCompatibility', 'local') === null ) {
                var self = this;
                var favoritesIndex = getCache('favoritesIndex', 'local');
                if( favoritesIndex && favoritesIndex.length > 0 ) {
                    $.each(favoritesIndex, function(sortOrder, index){
                        var deal = getCache('favorites'+index, 'local');
                        if( deal ) {
                            deal.sortOrder = sortOrder;
                            self.addToFavorites(deal);
                        }
                        removeCache('favorites'+index, 'local');
                    });
                }
                removeCache('favoritesIndex', 'local');
                removeCache('favoritesIndexBan', 'local');
                
                saveCache('oldVersionCompatibility', true, 'local')
            }
        },
        exists: function(dealID) {
            var self = this;
            
            if( self.isFavorite(dealID) || self.isRejected(dealID) ) {
                return true;
            } 
            return false;
        },
        isFavorite: function(dealID) {
            var self = this;
            if( self.deals.favorites[dealID] ) {
                return true;
            }
            return false;
        },
        isRejected: function(dealID) {
            var self = this;
            if( self.deals.rejected[dealID] ) {
                return true;
            }
            return false;
        },
        getDeal: function(dealID) {
            var self = this;
            var deal = {};
            
            $.each(['favorites', 'rejected'], function(i, type) {
                var deals = self.deals[type];
                $.each(deals, function(k, v) {
                    if( k == dealID ) {
                        deal = v;
                        deal.favoriteType = type;
                        return false;
                    }
                });   
            });
            return deal;
        },
        countFavorites: function() {
            var self = this;
            return Object.size(self.deals.favorites);
        },
        countRejected: function() {
            var self = this;
            return Object.size(self.deals.rejected);
        },
        clearOld: function() {
            var self = this;
            
            $.each(['favorites', 'rejected'], function(i, type) {
                var deals = self.deals[type];
                if( deals ) {
                    $.each(deals, function(k, v){
                        if( checkDealValidDate(v.EndDateGMT) !== true ) {
                            _log('clear old deal', type, v.Title, v.EndDateGMT);
                            self.removeDeal(v);
                        }
                    });
                }
            });
        },
        clearAll: function() {
            var self = this;
            self.clearAllFavorites();
            self.clearAllRejected();
        },
        clearAllFavorites: function() {
            var self = this;
            self.deals.favorites = {};
            self.saveData();
            _log('app.favourite', 'clearAllFavorites');
            app.logEvent('App', 'clearFavorites', 'Clear favorites');
        },
        clearAllRejected: function() {
            var self = this;
            self.deals.rejected = {};
            self.saveData();
            _log('app.favourite', 'clearAllRejected');
        },
        getSortIndex: function(type) {
            var self = this;
            var index = 0;
 
            if( self.deals[type] ) {
                $.each(self.deals[type], function(k, v){
                    if( v.sortOrder && v.sortOrder > index ) {
                        index = v.sortOrder;
                    }
                });
            }
            index = index + 1;
            
            return index;
        },
        removeDeal: function(deal) {
            var self = this;
            var result = false;
            if( deal !== 'undefined' && deal.ID ) {
                var deal = self.getDeal(deal.ID);
                if( deal && self.deals[deal.favoriteType] && self.deals[deal.favoriteType][deal.ID] ) {
                    app.logEvent('Deal', 'dealFavouriteRemove', 'Delete deal from favourites', {id: deal.ID, title: deal.Title, price: deal.Price});
                    delete self.deals[deal.favoriteType][deal.ID];
                    self.saveData();
                    
                    result = true;  
                }
            }
            return result;
        },
        addToFavorites: function(deal) {
            var self = this;
            var result = false;
            if( deal !== 'undefined' && deal.ID ) {
                delete self.deals.rejected[deal.ID];
                deal.sortOrder = self.getSortIndex('favorites'); //Object.size(self.deals.favorites);
                self.deals.favorites[deal.ID] = deal;
                self.saveData();
                app.logEvent('Deal', 'dealFavouriteAdd', 'Add to favorites', {id: deal.ID, title: deal.Title, price: deal.Price});
                result = true;
            } else {
                _log('app.favourite', 'addToFavorites', 'error', 'empty deal');
            }
            return result;
        },
        addToRejected: function(deal) {
            var self = this;
            var result = false;
            if( deal !== 'undefined' && deal.ID ) {
                deal.sortOrder = self.getSortIndex('rejected'); //Object.size(self.deals.rejected);
                self.deals.rejected[deal.ID] = deal;
                self.saveData();
                app.logEvent('Deal', 'dealReject', 'Reject Deal', {id: deal.ID, title: deal.Title, price: deal.Price});
                result = true;
            } else {
                _log('app.favourite', 'addToRejected', 'error', 'empty deal');
            }
            return result;
        },
        saveData: function() {
            var self = this;
            saveCache('deals', JSON.stringify(self.deals), 'local');
        },
        sortDeals: function(deals, sort) {
            var self = this;
            deals = self.toArray(deals);
            
            return deals.sort(function(a, b){
                if( sort == 'default' ) {
                    return a.sortOrder > b.sortOrder;
                } else if( sort == 'expiring' ) {
                    var dateA = moment(a.EndDate);
                    var dateB = moment(b.EndDate);
                    return dateA.diff(dateB, 'hours');
                }
            });
        },
        toArray: function(deals) {
            var array = [];
            if( Object.size(deals) > 0 ) {
                $.each(deals, function(k, v){
                    array.push(v);
                });
            }
            return array;
        },
        getRejectedDeals: function(sort) {
            var self = this;
            return self.sortDeals(self.deals.rejected, sort);
        },
        getFavoritesDeals: function(sort) {
            var self = this;
            return self.sortDeals(self.deals.favorites, sort);
        },
        hasExpiringDeals: function() {
            var self = this;
            var count = 0;
            
            if( self.deals.favorites ) {
                $.each(self.deals.favorites, function(k, v){
                    var diff = moment(v.EndDateGMT).diff(moment(getLondonDate()), 'hours');
                    if( diff < 12 ) {
                        count++;
                    }
                });
            }
            return count;
        }
    };

    function fDragendUpdate() {
        if (Vocabulary.dealsAll.length == currentDealIndex) {
            $("#addButtonActive").hide();
            $("#delButtonPassive").hide();
            $("#dealsConteiner").hide();
            $("#emptyConteiner").show();
        } else if (Vocabulary.dealsAll.length - 1 == currentDealIndex) {
            $('#dealsDiv').dragend({jumpToPage: 1});
        } else {
            $('#dealsDiv').dragend({jumpToPage: 2});
        }
    }

    function fInit() {
        $("#addButtonActive").show();
        $("#delButtonPassive").show();
    }

    function btnScale(id) {
        $('#'+id).css({
            transform: 'scale(1.2)'
        });
        
        setTimeout(function(){
            $('#'+id).css({
                transform: 'scale(1)'
            });
        }, 200);
    }

    function fButtonAdd() {
        btnScale('addButtonActiveI');
        swipeOpeationManualProcess('right');
    }

    function fButtonDel() {
        btnScale('delButtonPassiveI');
        swipeOpeationManualProcess('left');
    }

    function fButtonAddActivate() {
        //$("#addButtonActiveI").attr('class', 'icon icon-favorite-large grow');
        $("#addButtonActiveI").attr('class', 'icon icon-favorite-large');
        $("#delButtonPassiveI").attr('class', 'icon icon-remove-large icon-remove-large-disabled');
    }

    function fButtonDelActivate() {
        $("#addButtonActiveI").attr('class', 'icon icon-favorite-large icon-favorite-large-disabled');
        //$("#delButtonPassiveI").attr('class', 'icon icon-remove-large grow');
        $("#delButtonPassiveI").attr('class', 'icon icon-remove-large');
    }
    
    function fButtonDefaults() {
        $("#addButtonActiveI").attr('class', 'icon icon-favorite-large');
        $("#delButtonPassiveI").attr('class', 'icon icon-remove-large');
    }

    function favoriteAdd(id, dealData) {
        var result = false;
        if( id ) {
            dealData = dealData || Vocabulary.dealsAll[Vocabulary.dealsIndex[id]];
            if( dealData ) {
                result = app.favorite.addToFavorites(dealData);
            }
        }

        return result;
    }
    
    function favoriteBan(id, dealData) {
        var result = false;
        if( id ) {
            dealData = dealData || Vocabulary.dealsAll[Vocabulary.dealsIndex[id]];
            if( dealData ) {
                result = app.favorite.addToRejected(dealData);
            }
        }

        return result;
    }
    
    function favoriteDel(id, dealData) {
        var result = false;
        if( id ) {
            dealData = dealData || Vocabulary.dealsAll[Vocabulary.dealsIndex[id]];

            result = app.favorite.removeDeal(dealData);
        }
        return result;
    }  
    
    function favoriteClear(redirect) {
        var href = redirect || 'index.html';
        
        loading('show');
        
        function _favoriteClear() {
            app.favorite.clearAllFavorites();
            location.href = href;
        }
        

        
        if( navigator.notification ) {
            navigator.notification.confirm(
                'Do you really want to clear favourite deals?', 
                function(button){
                    if( button === 1 ) {
                        _favoriteClear();
                    } else {
                        loading('hide');
                    }
                }, 
                'Clear favorites', 
                ['Yes','Cancel']
            );
        } else {
            if( confirm('Do you really want to clear favourite deals?') ) {
                _favoriteClear();
            } else {
                loading('hide');
            }
        } 
        return false;
    }
    
    function initSwipeConteiner() {
        $("#container").swipe({
            swipeStatus:function(event, phase, direction, distance, duration, fingers)
            {
                if (isSwipeInAnimate) {
                    return false;
                }
                
                var mouseX = null;
                var mouseY = null;
                if (event['clientX']) {
                    mouseX = event.clientX;
                    mouseY = event.clientY;
                }
                else if (event['pageX']) {
                    mouseX = event.pageX;
                    mouseY = event.pageY;
                }
                else if (event.originalEvent && event.originalEvent.targetTouches && event.originalEvent.targetTouches[0]) {
                    var t = event.originalEvent.targetTouches[0];
                    mouseX = t.pageX;
                    mouseY = t.pageY;
                }
                else if (event.changedTouches && event.changedTouches[0]) {
                    mouseX = event.changedTouches[0].clientX;
                    mouseY = event.changedTouches[0].clientY;
                }
                
                swipeOperationDeal(phase, direction, distance, mouseX, mouseY, duration, fingers);
            },
            /*
            swipeLeft:function(event, direction, distance, duration, fingers) {
                swipeOperationDeal('left', direction, distance, duration, fingers);
            },
            swipeRight:function(event, direction, distance, duration, fingers) {
                swipeOperationDeal('right', direction, distance, duration, fingers);
            },
            */
            threshold: 150,
            fingers:'all',
            tap: function() {
                if( !activeConteiner ) {
                    activeConteiner = $(".containerDeal.active");
                }
                if( activeConteiner ) {
                    prepareNewDealDetails(activeConteiner.attr('data-id'));
                    setCorrectStyleNextDeal();
                    clearSwipeVars();
                }
            }
        });    
    }
    
    
    function swipeOpeationManualProcess(direction) {
        var wStart = Math.floor((imageContainerW+300)/2);
        
        swipeOperationDeal('start', direction, 0, wStart, 0);
        
        if (direction == "right") {
            var wEnd = wStart*2;
        } else {
            var wEnd = 0;
        }
        
        swipeOperationDeal('move', direction, wEnd, wEnd, 0, false, false, true);
        
        window.setTimeout(function(){ 
            swipeOperationDeal('end', direction, wEnd, wEnd, 0, false, false, true); 
        }, 300);
    }
    
    function swipeOperationDeal(phase, direction, distance, mouseX, mouseY, duration, fingers, needAnimate) {
        //console.log('phase:= '+phase+', direction:= '+direction+', distance:= '+distance+', mouseX:= '+mouseX+', mouseY:= '+mouseY);
        //var styleScheme = 'default';
        //var styleScheme = 'alt';
        var styleScheme = 'tinder';
        
        if (!activeConteiner) {
            activeConteiner = $(".containerDeal.active");
        }
        
        if (phase == "start") {
            
            isSwipeProcess = false;
            swipeMouseStartX = mouseX;
            swipeMouseStartY = mouseY;
            swipeOperationDealStart(activeConteiner, styleScheme, mouseY);
            
        }
        else if (phase == "move" || phase == "end" || phase == "cancel") {
            
            if (mouseX > swipeMouseStartX) {
                var directionX = "right";
                var distanceX  = mouseX - swipeMouseStartX;
            } else {
                var directionX = "left";
                var distanceX = Math.abs(swipeMouseStartX - mouseX);
            }
            
            if (mouseY > swipeMouseStartY) {
                var directionY = "down";
                var distanceY  = Math.abs(mouseY - swipeMouseStartY);
            } else {
                var directionY = "up";
                var distanceY = Math.abs(swipeMouseStartY - mouseY);
            }
            
            if (phase == "move") {
                
                isSwipeProcess = true;
                
                swipeOperationDealMove(activeConteiner, directionX, directionY, distanceX, distanceY, duration, styleScheme, needAnimate);
                
                if (directionX == "right" && swipeDirectionOldX != directionX) {
                    swipeDirectionOldX = directionX;
                    fButtonAddActivate();
                } else if (directionX == "left" && swipeDirectionOldX != directionX) {
                    swipeDirectionOldX = directionX;
                    fButtonDelActivate();
                }
            
            } else {
                
                // console.log('distanceX:='+distanceX);
                // console.log('distanceY:='+distanceY);
                
                if (activeConteiner) {
                    // if it's click
                    /*if (distanceX<4 && distanceY<4) {
                        prepareNewDealDetails(activeConteiner.attr('data-id'));
                        setCorrectStyleNextDeal();
                        clearSwipeVars();
                    }
                    // cancel
                    else*/ if( distanceX < 120 ) {
                        
                        swipeOperationDealCancel(activeConteiner, styleScheme, directionX, directionY, distanceX, distanceY);
                        fButtonDefaults();
                        //clear in cancel function already exists
                        //clearSwipeVars();
                    }
                    //end
                    else {
                        function _go() {
                            if (distanceX >= imageContainerW + 450 || needAnimate) {
                                if (isSwipeMarginSecondDeal) {
                                    setCorrectStyleNextDeal();
                                }
                                removeActiveConteiner(directionX);
                                clearSwipeVars();
                            } else {
                                if (isSwipeMarginSecondDeal) {
                                    setCorrectStyleNextDeal();
                                }

                                var distanseXEnd = swipeMouseStartX + Math.floor(imageContainerW/2);
                                //swipeOperationDeal('move', directionX, wEnd, wEnd, 0, false, false, true);
                                swipeOperationDealMove(activeConteiner, directionX, directionY, distanseXEnd, distanceY, false, styleScheme, true);

                                clearSwipeVars();

                                window.setTimeout(function(){ 
                                    removeActiveConteiner(directionX);
                                }, 100);
                            }
                        }
                        
                        var firstDragFavorite = getCache('firstDragFavorite', 'local') || false;
                        var firstDragRejected = getCache('firstDragRejected', 'local') || false;
                        var firstTapFavorite  = getCache('firstTapFavorite', 'local') || false;
                        var firstTapRejected  = getCache('firstTapRejected', 'local') || false;
                        
                        
                        
                        //if( firstDragFavorite && firstDragRejected && firstBtnFavorite && firstBtnRejected ) {
                        //    _go();
                        //} else {
                            var needConfirm = true;
                            
                            var confirmTitle, confirmText, confirmButtons;
                            if( directionX === 'right' ) {
                                
              
                                confirmTitle = "Like";

                                if( needAnimate === true ) { // button tap
                                    if( firstTapFavorite ) {
                                        needConfirm = false;
                                    } else {
                                        saveCache('firstTapFavorite', true, 'local');
                                    }
                                    
                                    confirmText = "Tapping the \"heart\" indicates that you like deal. Deal will be added to favourites list.";
                                } else {
                                    if( firstDragFavorite ) {
                                        needConfirm = false;
                                    } else {
                                        saveCache('firstDragFavorite', true, 'local');
                                    }

                                    confirmText = "Dragging deal right adds the deal to your favourites list";
                                } 

                                confirmButtons = ['Cancel','Like'];
                            } else {
                                saveCache('firstRejected', true, 'local');
                                
                                confirmTitle = "Nope";
                                
                                if( needAnimate === true ) { // button tap
                                    if( firstTapRejected ) {
                                        needConfirm = false;
                                    } else {
                                        saveCache('firstTapRejected', true, 'local');
                                    }
                                    
                                    confirmText = "Tapping \"cross\" rejects deal forever";
                                } else {
                                     if( firstDragRejected ) {
                                        needConfirm = false;
                                    } else {
                                        saveCache('firstDragRejected', true, 'local');
                                    }
                                    
                                    confirmText = "Dragging deal left rejects the deal";
                                }
                                confirmButtons = ['Cancel','Nope'];
                            }

                            //var confirmText = 'bla bla bla';
                            if( needConfirm ) {
                                if( navigator.notification ) {
                                    navigator.notification.confirm(
                                        confirmText, 
                                        function(button){
                                            if( button === 1 ) {
                                                swipeOperationDealCancel(activeConteiner, styleScheme, directionX, directionY, distanceX, distanceY);
                                                fButtonDefaults();
                                                return;
                                            } else {
                                                _go();
                                            }
                                        }, 
                                        confirmTitle, 
                                        confirmButtons
                                    );
                                } else {
                                    if( confirm(confirmText) ) {
                                        _go();
                                    } else {
                                        swipeOperationDealCancel(activeConteiner, styleScheme, directionX, directionY, distanceX, distanceY);
                                        fButtonDefaults();
                                        return;
                                    }
                                }
                            } else {
                                _go();
                            }
                        //}
                    }
                }   
            }
        }   
    }
    
    function swipeOperationDeal2(phase, direction, distance, mouseX, mouseY, duration, fingers, needAnimate) {
        var styleScheme = 'tinder';
        
        if (!activeConteiner) {
            activeConteiner = $(".containerDeal.active");
        }
       
        if (phase == "start") {
            isSwipeProcess = false;
            swipeMouseStartX = mouseX;
            swipeMouseStartY = mouseY;
            swipeOperationDealStart(activeConteiner, styleScheme, mouseY);
            
        } else if (phase == "move" || phase == "end" || phase == "cancel") {
            
            if (mouseX > swipeMouseStartX) {
                var directionX = "right";
                var distanceX  = mouseX - swipeMouseStartX;
            } else {
                var directionX = "left";
                var distanceX = Math.abs(swipeMouseStartX - mouseX);
            }
            
            if (mouseY > swipeMouseStartY) {
                var directionY = "down";
                var distanceY  = Math.abs(mouseY - swipeMouseStartY);
            } else {
                var directionY = "up";
                var distanceY = Math.abs(swipeMouseStartY - mouseY);
            }
            
            if (phase == "move") {
                
                isSwipeProcess = true;
                
                swipeOperationDealMove(activeConteiner, directionX, directionY, distanceX, distanceY, duration, styleScheme, needAnimate);
                
                if (directionX == "right" && swipeDirectionOldX != directionX) {
                    swipeDirectionOldX = directionX;
                    fButtonAddActivate();
                } else if (directionX == "left" && swipeDirectionOldX != directionX) {
                    swipeDirectionOldX = directionX;
                    fButtonDelActivate();
                }
            
            } else {
                
                // console.log('distanceX:='+distanceX);
                // console.log('distanceY:='+distanceY);
                
                if (activeConteiner) {
                    // if it's click
                    if (distanceX<2 && distanceY<2) {
                        prepareNewDealDetails(activeConteiner.attr('data-id'));
                        setCorrectStyleNextDeal();
                        clearSwipeVars();
                    }
                    // cancel
                    else if (distanceX<120) {
                        swipeOperationDealCancel(activeConteiner, styleScheme, directionX, directionY, distanceX, distanceY);
                        fButtonDefaults();
                        //clear in cancel function already exists
                        //clearSwipeVars();
                    }
                    //end
                    else {
                        if (distanceX >= imageContainerW + 450 || needAnimate) {
                            if (isSwipeMarginSecondDeal) {
                                setCorrectStyleNextDeal();
                            }
                            removeActiveConteiner(directionX);
                            clearSwipeVars();
                        }
                        else {
                            if (isSwipeMarginSecondDeal) {
                                setCorrectStyleNextDeal();
                            }
                            
                            var distanseXEnd = swipeMouseStartX + Math.floor(imageContainerW/2);
                            //swipeOperationDeal('move', directionX, wEnd, wEnd, 0, false, false, true);
                            swipeOperationDealMove(activeConteiner, directionX, directionY, distanseXEnd, distanceY, false, styleScheme, true);
                            
                            clearSwipeVars();

                            window.setTimeout(function(){ 
                                removeActiveConteiner(directionX);
                            }, 100);
                        }
                        
                    }
                }
                
            }
        }
        
    }
    
    function clearSwipeVars() {
        //activeConteiner = null;
        swipeDirectionOldX = "";
        swipeMouseStartX = 0;
        swipeMouseStartY = 0;                
        isSwipeInAnimate = false;
    }
    
    function swipeOperationDealStart(activeConteiner, scheme, mouseY) {
        
        if (scheme == "alt" || scheme == "tinder") {
            
            if ((imageContainerH*4/5 + ($(window).height()-imageContainerH)/2) > mouseY) {
                swipeMouseTouchPart = "top";
            }
            else {
                swipeMouseTouchPart = "bottom";
            }
            
            if ($(".containerDeal").size() <= 1) {
                //activeConteiner.find('.dealsConteinerShade1').hide();
                //activeConteiner.find('.dealsConteinerShade2').hide();
                $('#container_paging').hide();
            }
            else {
                if (isSwipeMarginSecondDeal && scheme == "tinder") {
                    setExclusiveStyleNextDeal();
                }
            }
            
            activeConteiner.css({
                'transform': 'translateX(0px) translateY(0px) translateZ(0px) rotateX(0deg) rotateY(0deg) rotateZ(0deg)'
            });
        }
        else {
            if ($(".containerDeal").size() <= 1) {
                //activeConteiner.find('.dealsConteinerShade1').hide();
                //activeConteiner.find('.dealsConteinerShade2').hide();
                $('#container_paging').hide();
            }
            activeConteiner.css({
                'transform': 'translateX(0px) translateY(0px) translateZ(0px) rotateX(0deg) rotateY(0deg) rotateZ(0deg)',
                '-webkit-transform-origin-x': '50%', 
                '-webkit-transform-origin-y': '50%'
            });
        }
        
    }
    
    function swipeOperationDealMove(activeConteiner, directionX, directionY, distanceX, distanceY, duration, scheme, needAnimate) {
        
        if (needAnimate) {
            isSwipeInAnimate = true;
        }
        // tinder
        if (scheme == "tinder") {
            
            if (imageContainerW) {
                //var yRotate = Math.floor(distanceX/(4*imageContainerW/200));
                var yRotate = distanceX/(4*imageContainerW/150);
                //if (yRotate==0) yRotate = 1;
            }
            else {
                //var yRotate = Math.floor(distanceX/4);
                var yRotate = distanceX/4;
            }
            
            var settings = { 
                    transform:  'translateX(' + ((directionX=="left") ? "-" : "") + (distanceX) + 'px) ' + 
                                'translateY(' + ((directionY=="up") ? "-" : "") + (distanceY) + 'px) ' +
                                'rotate(' + ((directionX=="left") ? ((swipeMouseTouchPart=="bottom") ?"" :"-") : ((swipeMouseTouchPart=="bottom") ?"-" :"")) + yRotate + 'deg)' 
                }; 
            if (newDealsSwipingTransition) {
                settings.transitionDuration = newDealsSwipingTransition;
            }
            if (needAnimate) {
                settings.opacity = "0.5";
                settings.transitionDuration = "0.8s";
            }
            
            if (directionY == "up") {
                
            }
            else {
                
            }
            
            activeConteiner.css(settings);
            
            if (directionX == "right") {
                if (needAnimate) {
                    activeConteiner.find(".btn-t.like").show();
                }
                else {
                    activeConteiner.find(".btn-t.nope").hide();
                    activeConteiner.find(".btn-t.like").css({ display: 'block', opacity: Math.floor(distanceX/40*100)/100 });
                }
            }
            else if (directionX == "left") {
                if (needAnimate) {
                    activeConteiner.find(".btn-t.nope").show();
                }
                else {
                    activeConteiner.find(".btn-t.like").hide();
                    activeConteiner.find(".btn-t.nope").css({ display: 'block', opacity: Math.floor(distanceX/40*100)/100 });
                }
            }         
            
            if (imageNewSecondType != "changed" && (distanceX > 40 || distanceY > 40)) {
                changeNewSecondImage();
            }
        }
        
        // alt
        else if (scheme == "alt") {
            
            if (imageContainerW) {
                var yRotate = Math.floor(distanceX/(4*imageContainerW/400));
            }
            else {
                var yRotate = Math.floor(distanceX/4);
            }
            if (directionX == "right") {
                if (needAnimate) {
                    activeConteiner.find(".btn-t.like").show();
                    activeConteiner.css({ opacity: 0.5, transform: 'translateX(' + (distanceX) + 'px) ' + 'rotate(' + yRotate + 'deg)', transitionDuration: '0.8s'});
                }
                else {
                    if (newDealsSwipingTransition) {
                        activeConteiner.css({ transform: 'translateX(' + (distanceX) + 'px) ' + 'rotate(' + yRotate + 'deg)', transitionDuration: newDealsSwipingTransition});
                    }
                    else {
                        activeConteiner.css({ transform: 'translateX(' + (distanceX) + 'px) ' + 'rotate(' + yRotate + 'deg)'});
                    }
                    activeConteiner.find(".btn-t.nope").hide();
                    activeConteiner.find(".btn-t.like").css({ 
                        display: 'block',
                        opacity: Math.floor(distanceX/40*100)/100
                    });
                }
            }
            else if (directionX == "left") {
                if (needAnimate) {
                    activeConteiner.find(".btn-t.nope").show();
                    activeConteiner.css({ opacity: 0.5, transform: 'translateX(-' + (distanceX) + 'px)' + 'rotate(-' + yRotate + 'deg)', transitionDuration: '0.8s'});
                }
                else {
                    if (newDealsSwipingTransition) {
                        activeConteiner.css({ transform: 'translateX(-' + (distanceX) + 'px)' + 'rotate(-' + yRotate + 'deg)', transitionDuration: newDealsSwipingTransition});
                    }
                    else {
                        activeConteiner.css({ transform: 'translateX(-' + (distanceX) + 'px)' + 'rotate(-' + yRotate + 'deg)'});
                    }
                    activeConteiner.find(".btn-t.like").hide();
                    activeConteiner.find(".btn-t.nope").css({ 
                        display: 'block',
                        opacity: Math.floor(distanceX/40*100)/100
                    });
                }
            }
        }
        
        // default
        else {
            
            if (imageContainerW) {
                var yRotate = Math.floor(distanceX/(4*imageContainerW/400));
            }
            else {
                var yRotate = Math.floor(distanceX/4);
            }
            if (directionX == "right") {
                //activeConteiner.css({ transform: 'rotateY('+Math.floor(distanceX/4)+'deg)' });
                activeConteiner.css({ transform: 
                    'translateX(' + (distanceX) + 'px) ' +
                    'translateY(' + (yTrans) + 'px) ' +
                    'rotateY(' + yRotate + 'deg)'
                });
                activeConteiner.find(".btn-t.nope").hide();
                activeConteiner.find(".btn-t.like").css({ 
                    display: 'block',
                    opacity: Math.floor(distanceX/40*100)/100
                });
            }
            else if (directionX == "left") {
                activeConteiner.css({ transform: 
                    'translateX(-' + distanceX + 'px)' +
                    'translateY(' + yTrans + 'px)' +
                    'rotateY(-' + yRotate + 'deg)'
                });
                activeConteiner.find(".btn-t.like").hide();
                activeConteiner.find(".btn-t.nope").css({ 
                    display: 'block',
                    opacity: Math.floor(distanceX/40*100)/100
                });
            }
        }
    }
    
    function swipeOperationDealCancel(activeConteiner, scheme, directionX, directionY, distanceX, distanceY) {
        if (scheme == "tinder") {
            
            isSwipeInAnimate = true;
            
            var transitionTime = 400;
            var transitionTimeCSS = '0.4s';
            var transitionTimeEasing = 100;
            var transitionTimeEasingCSS = '0.1s';
            
            
            if (isMobile.Android()) {
                if (imageContainerH > 500) {
                    var transitionTime = 1000;
                    var transitionTimeCSS = '0.8s';
                    var transitionTimeEasing = 500;
                    var transitionTimeEasingCSS = '0.3s';
                }
            }
            
            //activeConteiner.css({ transform: 'translateX(0px) translateY(0px) translateZ(0px) rotateX(0deg) rotateY(0deg) rotateZ(0deg)', transition: 'all 0.5s easeOutBack' });
            //activeConteiner.css("-webkit-translation-timing-function", "cubic-bezier(0.14,0.82,0.55,1)");
            
            //console.log('directionX: ' + directionX);
            //console.log('directionY: ' + directionY);
            //console.log('distanceX: ' + distanceX);
            //console.log('distanceY: ' + distanceY);
            
            var translateX = 0;
            var translateY = 0;
            
            if (distanceX > distanceY) {
                translateX = 5;
                translateY = Math.round(5/distanceX*distanceY);
            }
            else {
                translateX = Math.round(5/distanceY*distanceX);
                translateY = 5;
            }
            
            if (directionX=='right') {
                translateX = -1*translateX;
            }
            if (directionY=='down') {
                translateY = -1*translateY;
            }
            
            //console.log('translateX: '+translateX);
            //console.log('translateY: '+translateY);
            //console.log('activeConteiner: '+activeConteiner.size());
            //console.log(activeConteiner.css('transform'));
            
            if (isSwipeMarginSecondDeal) {
                setCorrectStyleNextDeal();
            }
            
            activeConteiner.css({ 
                transform: 'translateX(' + translateX + 'px) translateY(' + translateY + 'px) rotateY(0deg)',
                //translateX: translateX + 'px',
                //translateY: translateY + 'px',
                //rotateY:    '0deg',
                //transitionProperty: 'all',
                transitionDuration: transitionTimeCSS
                //transitionTimingFunction: 'easy'

                //transition: 'all 0.3s easyOutBack 0s' 
                //transition: 'all 0.3s cubic-bezier(.14,.82,.55,1) 0.1s' 
            });
            
            setTimeout(function(){
                
                activeConteiner.css({ 
                    transform: 'translateX(0px) translateY(0px) rotateY(0deg)',
                    opacity: 1,
                    //transitionProperty: 'all',
                    transitionDuration: transitionTimeEasingCSS
                });
                
                setTimeout(function(){
                    
                    activeConteiner.css({ 
                        transform: 'translateX(0px) translateY(0px) rotateY(0deg)',
                        transitionDuration: '' 
                    });
                    clearSwipeVars();
                    
                }, transitionTimeEasing);
                
            }, transitionTime);
            
            activeConteiner.find(".btn-t.like").hide();
            activeConteiner.find(".btn-t.nope").hide();
            
            resizeNewSecondImage(true, true);
        }
        else {
            activeConteiner.find(".btn-t.like").hide();
            activeConteiner.find(".btn-t.nope").hide();
            activeConteiner.css({ transform: 'translateX(0px) translateY(0px) translateZ(0px) rotateX(0deg) rotateY(0deg) rotateZ(0deg)' });
        }
    }

    function removeActiveConteiner(direction) {
        /*
        if (!activeConteiner) {
            activeConteiner = $(".containerDeal.active");
        }
        */
        if (activeConteiner) {
            
            if (direction == "right") {
                favoriteAdd(activeConteiner.attr('data-id'));
            } else if (direction == "left") {
                favoriteBan(activeConteiner.attr('data-id'));
            }
            
            activeConteiner.animate({opacity:0}, 300, function(){
                $(this).remove(); 
                initNextConteiner();
                activeConteiner = null; 
            });
            
            loadNextConteiner();    
        }
    }    

    function setCorrectStyleNextDeal() {
        if (isSwipeNextContainerID) {
            var nextDeal = $("#"+isSwipeNextContainerID);
            if (nextDeal.size()) {
                /*
                nextDeal.css({ 'margin-top': '0px', transitionProperty: 'all', transitionDuration: '0.3s' });
                setTimeout(function(){
                    if (nextDeal) {
                        nextDeal.css({ transitionProperty: 'none', transitionDuration: '' });
                        nextDeal = null;
                    }
                });
                */
            }
        }
    }
    
    function setExclusiveStyleNextDeal() {
        if (isSwipeNextContainerID) {
            /*
            $("#"+isSwipeNextContainerID).css({ 'margin-top': '-10px', transitionProperty: 'all', transitionDuration: '0.3s' });
            */
        }
    }
    
    function loadNextConteiner() {
        if (!indexDealLastFound && $(".containerDeal").size() <= 5 && Vocabulary.dealsLastFound == false) {
            dealsParams['offset'] = dealsParams['offset'] + dealsParams['limit'];
            getDealsList(dealsParams, true, 
                function() {
                    showNewDealsContainers();
                    resizeNewDealsImages(false, true);
                }
            ); 
        }
    }
    
    function initNextConteiner() {
        var nextContainer = $(".containerDeal:first");
        if (nextContainer.size()) {
            nextContainer.attr('class', 'containerDeal active');
            var secondContainer = $(".containerDeal").eq(1);
            if (secondContainer.size()) {
                
                isSwipeNextContainerID = secondContainer.attr('id');
                
                secondContainer.attr('class', 'containerDeal show');
                resizeNewDealsImages(true, true);
            }
            else {
                isSwipeNextContainerID = "";
                
                $(".dealsConteinerShade1").hide();
                $(".dealsConteinerShade2").hide();
                $(".dealsConteinerShade3").hide();
            }
            fButtonDefaults();
        }
        else {
            $("#footer").hide();
            $("#dealsConteiner").hide();
            
            if (Vocabulary.dealsNoConnection) {
                showNoConnectionScreen();
            }
            else {
                $("#emptyConteiner").show();
            }
        }
    }
    
    function prepareNewDealDetails(dealId) {
        if (dealId && !isSwipeProcess) {

            var index = Vocabulary.dealsIndex[dealId];
            if (index != undefined) {
                Vocabulary.deal = Vocabulary.dealsAll[index];
                
                if (Vocabulary.deal) {
                    saveCache('dealId', dealId);
                    showDealInfo(Vocabulary.deal);
                    //fixPageContainer();
                }
            }
        }
    }  
    
    function prepareSwipeDeals(lastDealId) {
        if( lastDealId && app.favorite.exists(lastDealId) ) {  
            removeActiveConteiner();
        }
        
        $('#dealInfo').hide();
        $('#deals').show();
        $(window).unbind("resize");
        
        saveCache('dealId', 0);
    }    
    
    function processDealToFavorites(idDeal, isFromFavoriteList) {
        var deal = app.favorite.getDeal(idDeal);
        if( deal ) {
            if( deal.favoriteType == 'favorites' ) {
                $("#iconFavorite").attr('class', 'icon icon-none-favorite-lg');
                favoriteDel(idDeal, Vocabulary.deal);
            } else {
                $("#iconFavorite").attr('class', 'icon icon-favorite-lg');
                if( isFromFavoriteList ) {
                    favoriteAdd(idDeal, Vocabulary.deal);
                } else {
                    favoriteAdd(idDeal);
                }
            }
        }
    }
    
    function resizeNewDealsField() {
        var conteinerH_Old = 0;
        
        // fix for Nexus 4
        var W = Vocabulary.clientWidth;
        var H = Vocabulary.clientHeight;
        if (!W) {
            W = $(window).width();
        }
        if (!H) {
            H = $(window).height();
        }
                
        // height - header - footer - fav buttons/2
        if (W >= 768) {
            var conteinerH_Full = H - 90 - 85 - 37;
        }
        else {
            var conteinerH_Full = H - 45 - 70 - 60;
        }
        
        // deal info: OFF % $
        conteinerH = conteinerH_Full - 100;

        // minimum
        /*
        if (conteinerH < 150) {
            conteinerH = 150;
        }
        */
       
        var conteinerW = Math.floor(conteinerH * 4 / 3);
        
        if (conteinerW > W * 0.9) {
            conteinerW = Math.floor(W * 0.9);
            conteinerH = Math.floor(conteinerW * 3 / 4);
        }
        
        /*
        if (conteinerW >= 350) {
            conteinerH_Old = conteinerH;
            if (conteinerW * 1.00 < conteinerH) {
                conteinerH_Old = conteinerH;
                conteinerH = Math.floor(conteinerW * 1.00);
            }
        }

        if (conteinerW < 250) {
            conteinerW = 250;
        }
        if (conteinerH < 150) {
            conteinerH = 150;
        }
        */
        
        imageContainerW = conteinerW;
        imageContainerH = conteinerH;
        
        // deal info: OFF % $
        conteinerH = conteinerH + 50;

        
        $("#container").css({ width: conteinerW, height: conteinerH });
        $("#container_paging").css({ width: conteinerW });
        
        //$("#container").css("margin-top", Math.floor((conteinerH_Full-conteinerH-70)/2)+"px");
       
        resizeNewDealsImages(true, true);
    }
    
    function resizeNewDealsImages(resizeFirstImage, resizeSecondImage) {
        if (imageContainerH && imageContainerW) {
            $("#container div.overlay").css({ height: imageContainerH, overflow: 'hidden' });
            if (resizeFirstImage) {
                resizeNewFirstImage();
            }
            if (resizeSecondImage) {
                resizeNewSecondImage(true);
            }
        }
        else {
            console.log('Error: fail container: w=' + imageContainerW + ', h=' + imageContainerH);
        }
    }
    
    function resizeNewFirstImage() {
        if (!resizeImage("#container > div.containerDeal.active img", imageContainerW, imageContainerH, false)) {
            if (isDebug) {
                console.log('First image not found');
            }
        }
    }
    
    function resizeNewSecondImage(useMargin, useAnimate) {
        if (!useMargin) {
            imageNewSecondType = "changed";
        }
        else {
            imageNewSecondType = "";
        }
        if (!resizeImage("#container > div.containerDeal.show img", imageContainerW, imageContainerH, useMargin, useAnimate)) {
            if (isDebug) {
                console.log('Second image not found');
            }
        }
    }
   
    function changeNewSecondImage() {
        resizeNewSecondImage(false, true);
    }

    function resizeImage(imageSelector, imageMaxW, imageMaxH, useMargin, useAnimate) {
        var image = $(imageSelector);
        
        if (useMargin) {
            var margin = 15;
        }
        else {
            var margin = 0;
        }
        
        if (image.size()) {
            
            if (isDebugImages) {
                console.log('imageMaxW: '+imageMaxW);
                console.log('imageMaxH: '+imageMaxH);
            }
            
            var wP = parseInt(image.attr("data-width"));
            var hP = parseInt(image.attr("data-height"));

            if (isDebugImages) {
                console.log('wP: '+wP);
                console.log('hP: '+hP);
            }

            var ratioW = imageMaxW / wP;
            var ratioH = imageMaxH / hP;

            if (ratioH < ratioW) {
                var ratio = ratioW;
            }
            else {
                var ratio = ratioH;
            }

            var imageW = Math.round(wP*ratio);
            var imageH = Math.round(hP*ratio);

            if (isDebugImages) {
                console.log('imageW: '+imageW);
                console.log('imageH: '+imageH);
            }
            
            var css = { width: imageW, height: imageH, position: 'absolute'};
            image.css(css);
            
            if (ratioH <= ratioW) {
                if (newDealsImageClip) {
                    var clip = 'rect(0px, ' + imageW + 'px, ' + imageH + 'px, 0px)';
                    css = { 
                        clip: clip,
                        marginTop: '-' + Math.floor((imageH-imageMaxH)/2)+'px'
                    };
                    if (useAnimate) {
                        css.transitionDuration = '0.5s';
                    }
                    else {
                        css.transitionDuration = '';
                    }
                    image.css(css);
                    
                    if (isDebugImages) {
                        console.log('Ratio W: ' + ratioW);
                        console.log('Ratio H: ' + ratioH);
                        console.log('clip top image part');
                        console.log('clip top image part');
                        console.log('clip: rect(Y1, X1, Y2, X2)');
                        console.log('clip: '+clip);
                    }
                }
                else {
                    image.css('margin-left', '0px');
                }
            }
            else {
                if (newDealsImageClip) {
                    var clip = 'rect(' + (margin) + 'px, ' + Math.floor(imageW - ((imageW-imageMaxW)/2) - margin) + 'px, ' + (imageH - margin) + 'px, ' + Math.floor(((imageW-imageMaxW)/2) + margin) + 'px)';
                    css = { 
                        clip: clip,
                        marginLeft: '-' + Math.floor((imageW-imageMaxW)/2)+'px'
                    };
                    if (useAnimate) {
                        css.transitionDuration = '0.5s';
                    }
                    else {
                        css.transitionDuration = '';
                    }
                    image.css(css);
                    
                    if (isDebugImages) {
                        console.log('Ratio W: ' + ratioW);
                        console.log('Ratio H: ' + ratioH);
                        
                        console.log('clip center image part');
                        console.log('clip: rect(Y1, X1, Y2, X2)');
                        console.log('clip: '+clip);
                        
                        console.log('Pading-left: ' + Math.floor((imageW-imageMaxW)/2));
                    }
                }
                else {
                    image.css('margin-left', -Math.floor((imageW-imageMaxW)/2)+'px');
                }
            }
            
            return true;
        }
        else {
            return false;
        }
    }
    
    function showNewDealsContainers() {
        var firstContainer = $(".containerDeal:first");
        if (firstContainer) {
            firstContainer.attr('class', 'containerDeal active');
        }
        var secondContainer = $(".containerDeal").eq(1);
        if (secondContainer) {
            secondContainer.attr('class', 'containerDeal show');
            isSwipeNextContainerID = secondContainer.attr('id');
        }
    }

    function showFavoriteDealsList(params, extendedFunc, isAppend) {
        loading('show', true);

        var count = 0;
        var deal = null;
        var deals = [];
        var sort = getParameterByName("sort", "default");
        
        if( params.type && params.type === 'rejected' ) {
            deals = app.favorite.getRejectedDeals(sort);
        } else {
            deals = app.favorite.getFavoritesDeals(sort);
        }

        if( deals.length > 0 ) {
            Vocabulary.deals = [];

            for( var i = params.offset; i < params.offset+params.limit; i++ ) {
                if( deals[i] ) {
                    var deal = deals[i];
                    if( checkDealValidDate(deal.EndDateGMT) ) {
                        var diff = moment(deal.EndDateGMT).diff(moment(getLondonDate()), 'hours');

                        if( diff < 12 ) {
                            deal.expiring = true;
                        }
                        Vocabulary.deals[count] = deal;
                        count++;
                    }
                }
            }
        }
        
        if (!count) {
            indexDealLastFound = true;
        }
        
        showList(isAppend);
        
        if (!indexDealLastFound) {
            if (extendedFunc) {
                extendedFunc();
            }
        }
        
        loading('hide', true);
    }

    function initInfiniteScroller() {
        $('#dealsContentScroller').infinitescroll({
            navSelector  	: "a#getDealsElement",
            nextSelector 	: "a#getDealsElement",
            itemSelector 	: "#dealsContentScroller ul",
            debug		 	: isDebugInfinite,
            dataType	 	: 'javascript',
            binder          : $(".page-content"),
            state           : {
                currPage    : 1
            },
            loading: {
                msg: $('<div class="txtC"><div class="circular-small"><div class="circularG circularG_1"></div><div class="circularG circularG_2"></div><div class="circularG circularG_3"></div><div class="circularG circularG_4"></div><div class="circularG circularG_5"></div><div class="circularG circularG_6"></div><div class="circularG circularG_7"></div><div class="circularG circularG_8"></div></div></div>'),
                msgText: null,
                speed: 0
            },
            appendCallback	: false, // USE FOR PREPENDING
            path : function( nextPage ) { 
                if (isDebugInfinite) {
                    console.log('nextPage:' + nextPage);
                }
                dealsParams.offset = (nextPage - 1) * dealsParams.limit; 
                return true;
            }
        }, function(empty, instance) {
            instance.loading.msg.appendTo(instance.loading.selector).show(instance.loading.speed);
            
            if( indexDealLastFound ) {
                instance.state.isDone = true;
                instance.loading.msg.fadeOut(instance.loading.speed);
                console.log('indexDealLastFound', indexDealLastFound);
                return false;
            }

            showFavoriteDealsList(dealsParams, "", true);
        });                    
    } 