var geo = {
    useTestCoordinates: false,
    lat: null,
    lng: null,
    force: false,
    timeStamp: null,
    isStartReceiveGEO: false,
    test: {
        lat: 51.508515,
        lng: -0.125487
    },
    test: {
        lat: 52.68198237293381,
        lng: -1.831623100117212
    },
    options: {
        enableHighAccuracy: true,
        timeout: geolocationTimeout
    },
    init: function(options){
        geo.isStartReceiveGEO = true;
        Vocabulary.coordinates = getCache('coordinates');

        geo.timeStamp = getCache('geoTimestamp', 'local') || new Date().getTime();
        
        if( Vocabulary.coordinates && Vocabulary.coordinates.lat != null && Vocabulary.coordinates.lng != null ) {
            geo.lat = Vocabulary.coordinates.lat;
            geo.lng = Vocabulary.coordinates.lng;
            
            if (useGEOMandatory) {
                app.dataLoading--;
            }
        }
        geo.force = options.force || false;
        
        if( isAlt != true ) {
            delete geo.options.timeout;
        } 

        _log('geo.init', 'lat is:', geo.lat, 'lng is:', geo.lng, 'timestamp:', geo.timeStamp, moment.unix(geo.timeStamp/1000).startOf('minute').fromNow());
        return this;
    },
    getCoordinates: function(options) { 
        if( geo.force || geo.lat === null && geo.lng === null ) {
            geo.timeStamp = new Date().getTime();
            saveCache('geoTimestamp', geo.timeStamp, 'local');
            
            _log('geo.getCoordinates', 'is forse:', geo.force, 'Timeout is:', (geo.options.timeout || 'no'), 'HighAccuracy is:', geo.options.enableHighAccuracy, 'timestamp:', geo.timeStamp);
            
            navigator.geolocation.getCurrentPosition(function(position){
                geo.getCoordinatesSuccess(position);
                if( options && options.successCallback ) {
                    options.successCallback();
                }
            }, function(error) {
                geo.getCoordinatesError(error);
                if( options && options.errorCallback ) {
                    options.errorCallback();
                }
            }, geo.options);
        }
    },
    getCoordinatesSuccess: function(position) {
        geo.lat = position.coords.latitude;
        geo.lng = position.coords.longitude;
        
        _log('geo.getCoordinatesSuccess', 'lat is:', geo.lat, 'lng is:', geo.lng);
        
        geo.saveCoordinates({
            lat: geo.lat,
            lng: geo.lng 
        }); 
        
        if (useGEOMandatory) {
            app.dataLoading--;
        }
    },   
    getCoordinatesError: function(error) {
        geo.saveCoordinates({
            lat: false,
            lng: false 
        });
        
        _log('geo.getCoordinatesError', error.message);
        
        if (isMobile.iOS()) {
            cordova.exec(function(status){
                if( status > 0 ) {
                    if (useGEOMandatory) {
                        app.dataLoading--;
                    }
                } else {
                    _log('No rights. make repeated request.');
                    setTimeout(geo.getCoordinates, 1000);
                }
            }, function(){}, "Geolocation", "getLocationStatus");
        } else {
            if (useGEOMandatory) {
                app.dataLoading--;
            }
        }
    },
    saveCoordinates: function(coordinates) {
        Vocabulary.coordinates = {
            lat: coordinates.lat,
            lng: coordinates.lng 
        };
        
        if( geo.useTestCoordinates ) {
            Vocabulary.coordinates = {
                lat: geo.test.lat,
                lng: geo.test.lng 
            };
        }

        _log('geo.saveCoordinates', 'Coordinates has been saved');
        
        saveCache('coordinates', JSON.stringify(Vocabulary.coordinates));
    }  
};
