function buildCityList() {
    if (Vocabulary.coordinates && Vocabulary.coordinates.lat && Vocabulary.coordinates.lng && $('#nearMe').length < 1) {
        $("#localList").prepend('<li class="near-me"><a id="nearMe" href="#" class="caret-right"><i class="icon icon-location-large mrs"></i> Near me</a></li>');
        $("#nearMe").on('click', function(e) {
            e.preventDefault();
            var selected = $(this);
            var diff = ((new Date().getTime() - geo.timeStamp)/1000)/60;
            if( diff < 30 ) {
                 _log('Near me click', 'still early to refresh city', diff);
                 redirectIt(selected);
            } else {
                loading('show');
                _log('Near me click', 'try to refresh city', diff);
                
                geo.init({force:true}).getCoordinates({
                    successCallback: function() {
                        redirectIt(selected);
                    },
                    errorCallback: function() {
                        redirectIt(selected);
                    }
                });
            }
            return false;
        });
    }

    function buildList(list) {
        if( list && Object.size(list) > 0 ) {
            $.each(list, function(k, v) {
                $("#localList").append('<li><a href="#" class="caret-right"><i class="icon icon-location-large mrs"></i> '+v.name+'</a></li>')
            });
        }
        loading('hide');
    }

    function redirectIt(selected) {
        var text = $.trim(selected.text());
        text = text.replace(/ \>/g, '');
        
        var params = {city: text};
        
        if( queryCategoryID ) {
            params.categoryID = queryCategoryID;
        }
        if( from ) {
            params.from = from;
        }

        app.logEvent('App', 'local', 'Select location', {id: 1, title: text});
        
        location.href = buildUrl("index.html", params);
    }

    buildList(Vocabulary.cities);
    
    $("body").on('click', '#localList li', function (e) {
        e.preventDefault();
        loading('show');
        redirectIt($(this));
    });
    
    $("#filterList").on('keyup', function() {
        $("#localList").empty();
        var query = $(this).val();
        var list = new Object();

        var pattern = new RegExp(query, 'i');
        
        $.each(Vocabulary.cities, function(k, v) {
            if( v.name.match(pattern) ) {
                list[k] = v;
            }
        });
        
        buildList(list);
    });
}