function profile() {
    loading('hide');
    
    var enable = false;
    
    $('#profileForm').find('input, select').on('change keyup', function(){
        $('.footer').removeClass('footer-disabled');
        enable = true;
    });

//    if( !app.user.isAuth ) {
//        location.href = 'login.html';
//        return false;
//    }
    
    $('#locations').append('<option value="all">All</option>');
    $.each(Vocabulary.cities, function(k, v) {
        $('#locations').append('<option value="'+v.name+'">'+v.name+'</option>');
    });

    $('.profile-line').on('click', function() {
        $('.profile-line').find('.icon-edit:not(.error)').show();
        $('.profile-line').find('.form-control').addClass('ui-input-text-disabled');

        $(this).find('.form-control').removeClass('ui-input-text-disabled');
        $(this).find('.icon-edit').hide();

        $(this).find('input, select').focus();
    });

    $.each(app.user.data, function(k, v) {
        switch(k) {
            case 'name':
                $('input[name=name]').val(v);
            break;
            case 'lastname':
                $('input[name=lastname]').val(v);
            break;
            case 'update':
                $('#lastUpdate').text(app.user.getLastUpdate());
            break;
            case 'email':
                $('input[name=email]').val(v);
            break;
            case 'password':
                $('input[name=password]').val(v);
            break;
            case 'emailNotificationFrequency':
                if( v ) {
                    $('select[name=email_notification_frequency]').val(v);
                }
            break;
            case 'defaultLocation':
                if( v ) {
                    $('select[name=default_location]').val(v);
                }
            break;
            case 'notifyWhenNewDeals':
                $('input[name=notify_when_new_deals]').removeAttr('checked');
                if( v == 1 ) {
                    $('input[name=notify_when_new_deals]').prop('checked', true);
                }
            break;
            case 'alertWhenExpire':
                $('input[name=alert_when_expire]').removeAttr('checked');
                if( v == 1 ) {
                    $('input[name=alert_when_expire]').prop('checked', true);
                }
            break;
        }
    });

    if( isAlt ) {
        var favoritesCount = app.favorite.countFavorites();
        if( favoritesCount > 0 ) {
            $('#favoritesClearButton').show().on('click', function(){
                favoriteClear('profile.html');
            });
        }
        $('#favoritesCount').text(favoritesCount);
    }

    $('#saveButton').on('click', function() {
        if( !enable ) {
            return;
        }
        loading('show');
        var form = $('#profileForm');
        var data = {
//            name: form.find('input[name=name]').val(),
//            lastname: form.find('input[name=lastname]').val(),
//            email: form.find('input[name=email]').val(),
//            password: form.find('input[name=password]').val(),
//            emailNotificationFrequency: form.find('select[name=email_notification_frequency]').val(),
            defaultLocation: form.find('select[name=default_location]').val(),
            notifyWhenNewDeals: parseInt( form.find('input[name=notify_when_new_deals]:checked').val() || 0 ),
            alertWhenExpire: parseInt( form.find('input[name=alert_when_expire]:checked').val() || 0 )
        };

        $('.error-symbol, .error-text').hide();
        $('.ui-input-text, .icon-edit').removeClass('error');

        var hasError = false;
        if( app.user.validation(data) ) {
            $('.ui-input-text').addClass('ui-input-text-disabled');

            app.user.setData(data).saveData();

            //alert('Data has been saved');
            $('#lastUpdate').text(app.user.getLastUpdate());
            $('.footer').addClass('footer-disabled');
            enable = false;
        } else {
            hasError = true; 
        }

        app.user.showErrors();
        if( hasError ) {
            $.each(app.user.errors, function(k, v){
                var input = $('input[name='+k+']');
                input.parents('.ui-input-text').removeClass('ui-input-text-disabled');

                //input.parents('.edit-line').find('.error-symbol').show();
                //input.parents('.edit-line').find('.error-text').html(v).show();
                input.parents('.edit-line').find('.icon-edit').addClass('error').hide();
            });
        }
        loading('hide');
    });
}