var share = {
    via: null,
    shareUrl: null,
    type: null,
    title: null,
    url: null,
    image: null,
    init: function(type, title, url, image) {
        var self = this;
        loading('show');
        
        var shareUrl;

        self.title = title;
        self.url = url;
        self.image = image;
        
        if( type == 'twitter' ) {
            shareUrl = "https://twitter.com/intent/tweet?url={url}&text={text}";
            self.via = (app.deviceType == "Android") ? "twitter" : "com.apple.social.twitter";

            var twit = self.title + self.url;
            if( twit.length > 140 ) {
                self.title = self.title.substring(0, (140 - 4 - self.url.length)) + '...';
            }    
        } else if( type == 'facebook' ) {
            shareUrl = "https://www.facebook.com/sharer/sharer.php?u={url}";
            self.via = (app.deviceType == "Android") ? "facebook" : "com.apple.social.facebook";
            self.image = null;    
        } else if( type == 'google' ) {
            shareUrl = "https://plus.google.com/share?url={url}";
            self.via = "com.google.android.apps.plus";     
            self.image = null;
        } else if( type == 'pinterest' ) {
            shareUrl = "http://www.pinterest.com/pin/create/button/?url={url}&media={image}&description={text}";
            self.via = "pinterest";
            self.image = null;
        }

        shareUrl = shareUrl.replace(/\{url\}/g, self.url);
        shareUrl = shareUrl.replace(/\{text\}/g, self.title);
        self.shareUrl = shareUrl.replace(/\{image\}/g, self.image);
        return self;
    },
    shareIt: function(callback) {
        var self = this;
        
        if( isMobile.iOS() && parseInt(app.device.version) > 7 && (self.via === 'com.google.android.apps.plus' || self.via === 'pinterest') ) {
            loading('hide');
            window.open(self.shareUrl, '_system');
            return true;
        }
        
        window.plugins.socialsharing.available(function(isAvailable) {
            if ( isAvailable ) {                       
                window.plugins.socialsharing.canShareVia(self.via, null, null, null, null, function(e){
                    window.plugins.socialsharing.shareVia(
                        self.via, 
                        decodeEntities(self.title), 
                        null, 
                        self.image, 
                        self.url, 
                        function() {
                            loading('hide');
                            if( callback ) {
                                callback(true);
                            }
                        }, 
                        function() {
                            loading('hide');
                            window.open(self.shareUrl, '_system');
                            if( callback ) {
                                callback(false);
                            }
                        }
                    );
                }, function() {
                    loading('hide');
                    if( callback ) {
                        callback(true);
                    }
                    window.open(self.shareUrl, '_system');
                });
            } else {
                loading('hide');
                if( callback ) {
                    callback(true);
                }
                window.open(self.shareUrl, '_system');
            }
        });
    }
};