var indexDealLastFound = false;
var indexDealCurrent = 0;
var indexDealLoadPage = 0;
var indexDealLastFound = false;

/* bof alt */
function getDealsList(params, isAppend, extendedFunc) {
    app.getDeals(
        params, 
        function() {
            if ((!Vocabulary.deals || !Vocabulary.deals.length) && !Vocabulary.dealsLastFound) {
                //dealsParams['offset'] = dealsParams['offset'] + dealsParams['limit'];
                getDealsList(dealsParams, isAppend, extendedFunc);
            }
            else {
                showNewDeals(0, isAppend);
            }

            if (isDebugDealsOnlyFirst) {
                indexDealLastFound = true;
            }
        }, 
        isAppend, 
        function() { //append func
            dealsParams['offset'] = dealsParams['offset'] + dealsParams['limit'];
            getDealsList(dealsParams, true, extendedFunc);
        }
    );
}

function showNewDeals(indexDeal, isAppend) {
    if (Vocabulary.dealsAll && Vocabulary.dealsAll.length) {
        if (Vocabulary.deals && Vocabulary.deals.length) {
            for (var i=0; i<Vocabulary.deals.length; i++) {
                buildNewDeal(Vocabulary.deals[i]);
            }
        }
    } else {
        if (!Vocabulary.dealsAll || !Vocabulary.dealsAll.length) {
            $("#loader").hide();
            showEmptyConteiner();
            indexDealLastFound = true;
        }
    }
}   

function showEmptyConteiner() {
    if (Vocabulary.dealsNoConnection) {
        showNoConnectionScreen();
    } else {
        if (dealsParams.query) {
            $("#emptyConteinerSearch").show();
        } else if (dealsParams.city) {
            $("#emptyConteinerLocal").show();
        } else {
            $("#emptyConteiner").show();
        }  
    }
}

function processPatternDeal(deal, dealPattern, bigImage) {
    var pattern = dealPattern;
    var href;
    var id;
    var image = 'assets/images/default/placeholder.png';
    var iconCity = 'icon-location';

    if( isAlt ) {
        href = "javascript:prepareDealFavorite("+deal.ID+")";
        id = "deal_list_"+deal.ID;
        pattern = pattern.replace(/\{imageDataWidth\}/g, deal.ImageLarge['width']);
        pattern = pattern.replace(/\{imageDataHeight\}/g, deal.ImageLarge['height']); 
    } else {
        href = "javascript:prepareDeal("+deal.ID+")";
        id = "deal"+deal.ID;
    }

    if( deal.ImageSmall['src'] ) {
        image = deal.ImageSmall['src'];
    }
    if( bigImage && deal.ImageLarge['src'] ) {
        image = deal.ImageLarge['src'];
    }

    var discount = "SPECIAL";
    var oldPrice = '';
    var newPrice = deal.Price;
    var CurrencySymbol = deal.CurrencySymbol;
    
    if (deal.DiscountPercent && deal.DiscountPercent > 0 ) {
        discount = deal.DiscountPercent + "% OFF";
        oldPrice = deal.CurrencySymbol + deal.OriginalPrice;
    } else if( deal.Price === 'HUGE' ) {
        discount = deal.DiscountPercent;
        newPrice = deal.Price;
        CurrencySymbol = '';
        pattern = pattern.replace(/<!--muted-->.*<!--\/muted-->/g, '');
    }
    
    newPrice = CurrencySymbol + newPrice;
    
    var city = deal.City;
    if( city === "National" ) {
        pattern = pattern.replace(/<!--localrow-->.*<!--\/localrow-->/g, '');
    } else if( deal.DistanceFromMe && getParameterByName("city") ) {
        if( deal.DistanceFromMe == 99.99 ) {
            city = "near " + city;
        } else {
            city = deal.DistanceFromMe + " miles away";
            iconCity = 'icon-divider';
        }
    }
    
    var expiring = '';
    if( deal.expiring ) {
        expiring = $('#expiring').val();
    }
    pattern = pattern.replace(/{expiring}/, expiring);

    deal._city = city;

    pattern = pattern.replace(/\{dealId\}/g, deal.ID);
    pattern = pattern.replace(/\{iconCity\}/, iconCity);
    pattern = pattern.replace(/\{id\}/g, id);
    pattern = pattern.replace(/\{href\}/, href);
    pattern = pattern.replace(/\{image\}/, image);
    pattern = pattern.replace(/\{title\}/, deal.Title);
    pattern = pattern.replace(/\{city\}/, city);
    pattern = pattern.replace(/\{oldPrice\}/, oldPrice);
    pattern = pattern.replace(/\{newPrice\}/, newPrice);
    pattern = pattern.replace(/\{discount\}/, discount);

    return pattern;
}

function buildNewDeal(deal) {
    if (deal) {
        var pattern = $("#pattern-deal-list").val();

        pattern = processPatternDeal(deal, pattern, true);
        $('#container').append(pattern);
    }
}
/* eof alt */

function showNoConnectionScreen() {
    loading('hide');
    $("#noConnection").show();
    $("#topCategories").hide();
    $("#localDiv").hide();
    fixMiddleContainer({
        container: '#noConnection'
    });
    $('#header').css('z-index', '99999');
}

function showList(isAppend, target) {
    target = target || '#dealsList';

    if (Vocabulary.deals && Vocabulary.deals.length) {
        if (!isAppend) {
            $(target).empty();
        }

        var dealPattern = $("#pattern-deal-list").val().replace(/\s+/g, ' ');
        $.each(Vocabulary.deals, function(i, deal){
            if( deal ) {
                pattern = processPatternDeal(deal, dealPattern);

                (function(pattern){
                    setTimeout(function(){
                        $(target).append(pattern);
                    }, 10);  
                })(pattern);  
            }
        });
    } else {
        if( !isAppend ) {
            if( isAlt ) {
                $("#emptyConteiner").show();
            } else {
                $(target).parent('.scroller').html( $('#emptyConteiner').val() );
                fixMiddleContainer({
                    container: ".scroller"
                });
            }
        } else {
            //$('#dealsContentScroller').infinitescroll('pause');
        }
    }
}

function prepareDeals(lastDealId) {
    $(window).unbind("resize.image");
    
    if( isAlt ) {
        if (lastDealId) {
            var type = getParameterByName("type", "favorites");
            if( (type == 'favorites' && app.favorite.isFavorite(lastDealId) !== true) || (type == 'rejected' && app.favorite.isRejected(lastDealId) !== true) ) {
                if( $('#deal_list_'+lastDealId).size() ) {
                    $('#deal_list_'+lastDealId).parent().remove();
                }
            }
        }
        if( $('#dealsList > li').size() < 1 ) {
            $('#favorites-footer').hide(); 
            $("#emptyConteiner").show();
        }

//        if (!indexDealLastFound) {
//            $('#dealsContentScroller').infinitescroll('resume');
//        }
    } else {
        //$('#dealsContentScroller').infinitescroll('resume');
    }
    
    $('#dealInfo').css('z-index', -1).hide();
    
    fixPageContainer();
    
    saveCache('dealId', 0);
}

function prepareDeal(id) {
    saveCache('dealId', id);

    //window.history.pushState('', '', location.href + '&dealId='+id);

    app.getDeal(id, function() {
        if (Vocabulary.deal) {
            showDealInfo(Vocabulary.deal);
        }
    });
}

function fixMiddleContainer(options) {
    var options = options || {};
    var container = options.container || '.page-content:visible';

    $('.absoluteCMiddle').each(function(k, v){ 
        $(v).css('margin-top', -$(v).outerHeight()/2); 
    });
}

function fixPageContainer(options) {
    var options = options || {};
    var container = options.container || '.page-content:visible';
    var header = options.header || 'header:visible';
    var footer = options.footer || 'footer:visible';

    var top = $(header).outerHeight();
    var bottom = $(footer).outerHeight();

    if( options.top !== undefined ) {
        $.each(options.top, function(k, id){
            top += $(id).outerHeight(true);
        });
    }
    if( options.bottom !== undefined ) {
        $.each(options.bottom, function(k, id){
            bottom += $(id).outerHeight(true);
        });
    }

    $(container).css({
        'margin-top': top, 
        'margin-bottom': bottom,
        'height': $(window).height() - top - bottom
    });
}

function prepareDealFavorite(id) {
    if( !indexDealLastFound ) {
        //$('#dealsContentScroller').infinitescroll('pause');
    }

    saveCache('dealId', id);

    //var type = getParameterByName("type", "favorites");
    Vocabulary.deal = app.favorite.getDeal(id); //favoriteDealGetCache(id, type);

    showDealInfo(Vocabulary.deal);
}

function showDealInfo(deal) {
    if (deal) {

        
        var indexLink = (app.pageName == 'favorites.html') ? $('#favorites-deals > a') : $('#national-deals > a');
        indexLink.attr('href', indexLink.data('href'));
          
        buildDealInfo(deal);

        if( !isAlt ) {
            $(window).on('resize.image', applyImageParamsForDeal);
        }
       
        $('#dealInfo').css('z-index', 99998).show();
        applyImageParamsForDeal();
    }
}

function applyImageParamsForDeal() {
    if ($(window).height() > 340) {
        var wConteiner, hConteiner;
        if ($(window).width() <= $(window).height()) {
            hConteiner = $(window).height() - 340;
            wConteiner = $(window).width()+12;
        }
        else {
            hConteiner = $(window).height() - 120;
            if ($(window).width() > 1024) {
                wConteiner = Math.floor(1024 * 0.45) + 100;
            } else {
                wConteiner = Math.floor($(window).width() * 0.45);
            }
        }

        var hP = parseInt($('#patternDealImageLarge').attr("data-height"));
        var wP = parseInt($('#patternDealImageLarge').attr("data-width"));

        var ratioH = hConteiner / hP;
        var ratioW = wConteiner / wP;

        var ratio = ratioH;
        if( ratioH * wP > wConteiner ) {
            ratio = ratioW;
        }

        $('#patternDealImageLarge').css({ height: Math.floor(hP * ratio), width: '' });
    }
    
    fixPageContainer({
        header:'#dealInfo header', 
        footer:'#dealInfo footer', 
        container:'#dealInfo .page-content'
    });
}

function buildDealInfo(deal) {
    if (deal) {
        var patternSocial = $("#socialLinks").val();
        var type = getParameterByName("type", "favorites");

        patternSocial = patternSocial.replace(/\{id\}/g, deal.ID);

        var styleClass = 'icon icon-favorite-lg';

        if( type == 'rejected' ) {
            styleClass = 'icon icon-none-favorite-lg';
        }
        patternSocial = patternSocial.replace(/\{href\}/, 'javascript:processDealToFavorites('+deal.ID+', true)');
        patternSocial = patternSocial.replace(/\{class\}/, styleClass);
        patternSocial = patternSocial.replace(/\{url\}/g, DomainUrl + "out/"+deal.ID);
        patternSocial = patternSocial.replace(/\{text\}/g, deal.Title);
        patternSocial = patternSocial.replace(/\{image\}/g, deal.ImageLarge['src']);

        $('#patternSocialLinks').html(patternSocial);
        createSocialClick(deal);

        $('#patternDealTitle').html(deal.Title);

        if( deal.City && deal.City != "National" ) {
            $('#patternDealCity').parents('.location-row').show();
            $('#patternDealCity').html(deal.City);
        }

        var iconCity = 'icon-location';

        if( deal._city == "National" ) {
            $('#dealInfo .location-row').hide();
        } else {
            $('#dealInfo .location-row').show();
            if( deal._city && location.pathname.match(/index.html/) ) {
                $('#patternDealCity').html(deal._city);
                if( deal._city.match(/miles\saway/) ) {
                    iconCity = 'icon-divider';
                }
            }
        }

        $('p.location-row .icon').removeClass('icon-divider').removeClass('icon-location').addClass(iconCity);



        var discount = "SPECIAL";
        var originalPrice = '';
        var newPrice = deal.Price;
        var CurrencySymbol = deal.CurrencySymbol;
    
        $('.slash').show();
    
        if (deal.DiscountPercent && deal.DiscountPercent > 0 ) {
            discount = deal.DiscountPercent + "% OFF";
            originalPrice = deal.CurrencySymbol + deal.OriginalPrice;
        } else if( deal.Price === 'HUGE' ) {
            discount = deal.DiscountPercent;
            newPrice = deal.Price;
            CurrencySymbol = '';
            $('.slash').hide();
        }
    
        newPrice = CurrencySymbol + newPrice;

        $('#patternDealPrice').html(newPrice);
        $('#patternDealPrice2').html(newPrice);

        $('#patternDealOriginalPrice').html(originalPrice);
        $('#patternDealOriginalPrice2').html(originalPrice);

        $('#patternDealDiscountPercent').html(discount);
        $('#patternDealDiscountPercent2').html(discount);

        $('#patternDealImageLarge').attr("src", deal.ImageLarge['src']).attr("height", "").attr("width",  "").attr("data-height", deal.ImageLarge['height']).attr("data-width", deal.ImageLarge['width']);

        // show source image
        var source = '';
        if (Vocabulary.sourcesIndex) {
            var sourceIndex = Vocabulary.sourcesIndex[deal.SourceID];
            if (deal.SourceID && sourceIndex != undefined && Vocabulary.sources[sourceIndex]) {
                source = "<img src='" + DomainUrl + "images/sources/" + Vocabulary.sources[sourceIndex]['name'].toLowerCase() + ".png' alt='' />";
            }
        }

        $('#patternDealSource').html(source);

        $('#patternDealDescription').html('<p id="expand'+deal.ID+'">'+clearString(deal.Description)+'&nbsp;</p>');

        $("#expand"+deal.ID).jTruncate({
            length: 45,
            moreText: "See more",  
            lessText: "See less"                
        });

        $('#patternBuyNowLink, #patternDealTitle').unbind("click").on("click", function(e) {
            app.logEvent('Deal', 'dealBuy', 'Buy a deal', {id: deal.ID, title: deal.Title, price: deal.Price});
            window.open(deal.AffURL, '_system'); 
            return false;
        });

        //End in 3d 11h 5 min
        var d1=getLondonDate();
        var d2=new Date(deal.EndDateGMT.replace(/(\d+)-(\d+)-(\d+)/, '$2/$3/$1'));
        var diff=d2-d1,sign=diff<0?-1:1,milliseconds,seconds,minutes,hours,days;

        diff/=sign;
        diff=(diff-(milliseconds=diff%1000))/1000;
        diff=(diff-(seconds=diff%60))/60;
        diff=(diff-(minutes=diff%60))/60;
        days=(diff-(hours=diff%24))/24;

        var s = "";
        if (days) {
            s += days +"d ";
        }
        if (days || hours) {
            s += hours + "h ";
        }
        if (days || hours || minutes) {
            s += minutes + "min"; 
        }

        $('#patternDealEndDateTitle').html("Ends in " + s);

        app.logEvent('Deal', 'dealView', 'View the deal', {id: deal.ID, title: deal.Title, price: deal.Price});
    }
}

function createSocialClick(deal) {
    $('#patternSocialLinks').find('a.social').unbind('click').on('click', function(e) {
        e.preventDefault();
        var id = $(this).attr('id');
        var type = id.replace(/Share/i, '');

        var dealUrl = DomainUrl + "out/"+deal.ID;

        share.init(type, deal.Title, dealUrl, deal.ImageLarge['src']).shareIt(function(status){
            app.logEvent('Deal', 'dealShare', 'Share a deal', {id: deal.ID, title: deal.Title, price: deal.Price});
        });

        return false;
    });   
}

function showDealsList(params, extendedFunc, isAppend) {
    loading('show', true);
    app.getDeals(params, function(deals) {
        showList(isAppend);
        if (extendedFunc) {
            extendedFunc();
        }
        loading('hide', true);
    });
}

function setHeightForDeals() {
    var hDeals = $(window).height() - $("#header").height() - $("#categoriesListTopWrapper").height() - $("#localDiv").height();
    $("#dealsContentWrapper").height(hDeals);
}

function initInfiniteScroller() {  
    $('#dealsContentScroller').infinitescroll({
        navSelector  	: "a#getDealsElement",
        nextSelector 	: "a#getDealsElement",
        itemSelector 	: "#dealsContentScroller ul li",
        debug		 	: false,
        dataType	 	: 'javascript',
        binder          : $("#container"),
        behavior        : 'custom',
        state           : {
            currPage    : 1
        },
        loading: {
            img: null,
            msg: $('<div class="txtC"><div id="circular-small"><div id="circularG_1" class="circularG"></div><div id="circularG_2" class="circularG"></div><div id="circularG_3" class="circularG"></div><div id="circularG_4" class="circularG"></div><div id="circularG_5" class="circularG"></div><div id="circularG_6" class="circularG"></div><div id="circularG_7" class="circularG"></div><div id="circularG_8" class="circularG"></div></div></div>'),
            msgText: null,
            speed: 0
        },
        appendCallback	: false, // USE FOR PREPENDING
        path         	: function( nextPage ) { 
            dealsParams.offset = (nextPage - 1) * dealsParams.limit; 
            return app.getApiDealsUrl(dealsParams); 
        }
    }, function( empty, instance ) {
        instance.state.currentPage = instance.state.currentPage || 2;

        app.sendRequestCache = function() {
            instance.state.lock = true;
            instance.state.isDone = true;

            _log('app.sendRequestCache');

            var url = instance.path(instance.state.currentPage);
            $(instance.navSelector).hide();
            instance.loading.msg
                    .appendTo(instance.loading.selector)
                    .show(instance.loading.speed);

            app.sendRequest({
                log: ['infinitScroll', url],
                dataType: 'json',
                type: 'GET',
                url: url,
                complete: function() {
                    instance.state.isDone = false;
                    instance.loading.msg.fadeOut(instance.loading.speed);
                },
                success: function (response) {
                    app.dataLoading++;
                    getDealsSuccess(response);
                    showList(true);
                    instance.state.currentPage++;
                    app.sendRequestCache = null;
                    instance.state.lock = false;
                    if( response.deals && response.deals.length < 1 ) {
                        instance.state.lock = true;
                        _log('infinitScroll', 'isBeyondMaxPage');
                    }
                },
                error: function() {
                    if( leave == false ) {
                        instance.state.lock = false;
                        if( navigator.notification ) {
                            navigator.notification.confirm(
                                'Please try again', 
                                function(buttonIndex){
                                    if( buttonIndex == 1 ) {
                                        app.sendRequestCache();
                                    }
                                }, 
                                'We could not reach the server', 
                                ['Try again','Cancel']
                            );
                        } else {
                            if( confirm('We could not reach the server. Please try again') ) {
                                app.sendRequestCache();
                            }
                        }
                    }
                    return;
                }
            });
            return;
        };

        if( instance.state.lock != true && app.sendRequestCache ) {
            app.sendRequestCache(); 
        }
    }); 

    (function($, undefined) {
        $.extend($.infinitescroll.prototype,{
            _nearbottom_custom: function () {   
                var opts = this.options;
                var pixelsFromWindowBottomToBottom = (opts.binder.find('#dealsList').outerHeight(true) - opts.binder.height()) - opts.binder.scrollTop();
                return pixelsFromWindowBottomToBottom < opts.bufferPx;
            }
        });
    })(jQuery);   
}